/*      Compiler: ECL 16.0.0                                          */
/*      Source: SRC:CLX;TRANSLATE.LISP                                */
#include <ecl/ecl-cmp.h>
#include "clx/translate.eclh"
/*      function definition for DEFINE-KEYSYM-SET                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1define_keysym_set(cl_object v1set, cl_object v2first_keysym, cl_object v3last_keysym)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v4first_keysym;
  unsigned int v5last_keysym;
  v4first_keysym = ecl_to_uint(v2first_keysym);
  v5last_keysym = ecl_to_uint(v3last_keysym);
TTL:
  if (!(ecl_number_compare(ecl_make_uint(v4first_keysym),ecl_make_uint(v5last_keysym))>0)) { goto L1; }
  {
   unsigned int v6;
   v6 = v5last_keysym;
   {
    unsigned int v7;
    v7 = v4first_keysym;
    v4first_keysym = v6;
    v5last_keysym = v7;
   }
  }
L1:;
  T0 = ecl_symbol_value(VV[0]);
  T1 = (ECL_SYM("CAR",180)->symbol.gfdef);
  cl_set(VV[0],cl_delete(4, v1set, T0, ECL_SYM("KEY",1265), T1));
  {
   cl_object v6;
   v6 = ecl_symbol_value(VV[0]);
   goto L16;
L15:;
   {
    cl_object v7set;
    v7set = ecl_car(v6);
    {
     cl_object v8;
     cl_object v9;
     v8 = ecl_cadr(v7set);
     v9 = ecl_caddr(v7set);
     if ((cl_LE(3, v8, ecl_make_uint(v4first_keysym), v9))!=ECL_NIL) { goto L24; }
     if (Null(cl_LE(3, v8, ecl_make_uint(v5last_keysym), v9))) { goto L20; }
     goto L23;
L24:;
L23:;
     cl_error(2, VV[3], v7set);
    }
L20:;
   }
   v6 = ecl_cdr(v6);
L16:;
   if (Null(v6)) { goto L28; }
   goto L15;
L28:;
  }
  T0 = cl_list(3, v1set, ecl_make_uint(v4first_keysym), ecl_make_uint(v5last_keysym));
  cl_set(VV[0],CONS(T0,ecl_symbol_value(VV[0])));
  value0 = v1set;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for KEYSYM-SET                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2keysym_set(cl_object v1keysym)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v2keysym;
  v2keysym = ecl_to_uint(v1keysym);
TTL:
  {
   cl_object v3;
   v3 = ecl_symbol_value(VV[0]);
   goto L4;
L3:;
   {
    cl_object v4set;
    v4set = ecl_car(v3);
    {
     cl_object v5;
     cl_object v6;
     v5 = ecl_cadr(v4set);
     v6 = ecl_caddr(v4set);
     if (Null(cl_LE(3, v5, ecl_make_uint(v2keysym), v6))) { goto L8; }
     value0 = ecl_car(v4set);
     cl_env_copy->nvalues = 1;
     return value0;
    }
L8:;
   }
   v3 = ecl_cdr(v3);
L4:;
   if (Null(v3)) { goto L14; }
   goto L3;
L14:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function KEYSYM                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3keysym(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym;
   cl_object v5bytes;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym = v6;
   }
   {
    cl_object v6;
    v6 = v3;
    if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
    v5bytes = v6;
   }
   {
    cl_object v6;
    v6 = v4keysym;
    {
     cl_object v7;
     v7 = ecl_make_fixnum(0);
     if (!(ECL_FIXNUMP(v6)||ECL_BIGNUMP(v6))) { goto L12; }
     v7 = v6;
     if (!(ecl_number_compare(v7,ecl_make_fixnum(0))>=0)) { goto L12; }
    }
    {
     cl_object v7;
     v7 = v5bytes;
     goto L21;
L20:;
     {
      cl_object v8b;
      v8b = ecl_car(v7);
      T0 = cl_ash(v4keysym, ecl_make_fixnum(8));
      v4keysym = ecl_plus(T0,v8b);
     }
     v7 = ecl_cdr(v7);
L21:;
     if (Null(v7)) { goto L29; }
     goto L20;
L29:;
     value0 = v4keysym;
     cl_env_copy->nvalues = 1;
     return value0;
    }
L12:;
    T0 = L17character__keysyms(1, v4keysym);
    value0 = ecl_car(T0);
    if ((value0)!=ECL_NIL) { goto L32; }
    value0 = cl_error(2, VV[6], v4keysym);
    return value0;
L32:;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      local function KEYSYM-MAPPING-OBJECT                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4keysym_mapping_object(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym_mapping;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym_mapping = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, ECL_SYM("FIRST",371), v4keysym_mapping);
   return value0;
  }
 }
}
/*      local function KEYSYM-MAPPING-TRANSLATE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC5keysym_mapping_translate(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym_mapping;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym_mapping = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, ECL_SYM("SECOND",740), v4keysym_mapping);
   return value0;
  }
 }
}
/*      local function KEYSYM-MAPPING-LOWERCASE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC6keysym_mapping_lowercase(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym_mapping;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym_mapping = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, ECL_SYM("THIRD",857), v4keysym_mapping);
   return value0;
  }
 }
}
/*      local function KEYSYM-MAPPING-MODIFIERS                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC7keysym_mapping_modifiers(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym_mapping;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym_mapping = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, ECL_SYM("FOURTH",389), v4keysym_mapping);
   return value0;
  }
 }
}
/*      local function KEYSYM-MAPPING-MASK                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC8keysym_mapping_mask(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4keysym_mapping;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4keysym_mapping = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, ECL_SYM("FIFTH",351), v4keysym_mapping);
   return value0;
  }
 }
}
/*      function definition for DEFINE-KEYSYM                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L11define_keysym(cl_narg narg, cl_object v1object, cl_object v2keysym, ...)
{
 cl_object T0, T1, T2;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 {
  unsigned int v3keysym;
  cl_object v4lowercase;
  cl_object v5translate;
  cl_object v6modifiers;
  cl_object v7mask;
  cl_object v8display;
  ecl_va_list args; ecl_va_start(args,v2keysym,narg,2);
  v3keysym = ecl_to_uint(v2keysym);
  {
   cl_object keyvars[10];
   cl_parse_key(args,5,L11define_keysymkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v4lowercase = keyvars[0];
   v5translate = keyvars[1];
   v6modifiers = keyvars[2];
   v7mask = keyvars[3];
   v8display = keyvars[4];
  }
  {
   cl_object v9entry;
   if (Null(v7mask)) { goto L3; }
   if ((v7mask)==(VV[15])) { goto L5; }
   LC10mask_check(v7mask);
L5:;
   if (v6modifiers==ECL_NIL) { goto L9; }
   if (!(ecl_numberp(v6modifiers))) { goto L7; }
   if (!(ecl_zerop(v6modifiers))) { goto L7; }
   goto L8;
L9:;
L8:;
   cl_error(1, VV[18]);
L7:;
   v9entry = cl_list(5, v1object, v5translate, v4lowercase, v6modifiers, v7mask);
   goto L2;
L3:;
   if (Null(v6modifiers)) { goto L12; }
   LC10mask_check(v6modifiers);
   v9entry = cl_list(4, v1object, v5translate, v4lowercase, v6modifiers);
   goto L2;
L12:;
   if (Null(v4lowercase)) { goto L15; }
   v9entry = cl_list(3, v1object, v5translate, v4lowercase);
   goto L2;
L15:;
   if (Null(v5translate)) { goto L17; }
   v9entry = cl_list(2, v1object, v5translate);
   goto L2;
L17:;
   v9entry = ecl_list1(v1object);
L2:;
   if (Null(v8display)) { goto L19; }
   {
    cl_object v10previous;
    T0 = ecl_function_dispatch(cl_env_copy,VV[77])(1, v8display) /*  DISPLAY-KEYSYM-TRANSLATION */;
    v10previous = ecl_assql(ecl_make_uint(v3keysym),T0);
    if (Null(v10previous)) { goto L22; }
    {
     cl_object v11;
     T0 = ecl_cdr(v10previous);
     v11 = LC9merge_keysym_mappings(v9entry, T0);
     {
      cl_object v12;
      v12 = v10previous;
      if (ecl_unlikely(ECL_ATOM(v12))) FEtype_error_cons(v12);
      T0 = v12;
     }
     (ECL_CONS_CDR(T0)=v11,T0);
     goto L1;
    }
L22:;
    {
     cl_object v12;
     cl_object v13;
     v12 = cl_list(2, ecl_make_uint(v3keysym), v9entry);
     T0 = ecl_function_dispatch(cl_env_copy,VV[77])(1, v8display) /*  DISPLAY-KEYSYM-TRANSLATION */;
     v13 = CONS(v12,T0);
     ecl_structure_set(v8display,VV[19],55,v13);
     goto L1;
    }
   }
L19:;
   T0 = ecl_symbol_value(VV[7]);
   T2 = ecl_gethash_safe(ecl_make_uint(v3keysym),ecl_symbol_value(VV[7]),ECL_NIL);
   T1 = LC9merge_keysym_mappings(v9entry, T2);
   si_hash_set(ecl_make_uint(v3keysym), T0, T1);
  }
L1:;
  value0 = v1object;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function MASK-CHECK                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC10mask_check(cl_object v1mask)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (ecl_numberp(v1mask)) { goto L1; }
  {
   cl_object v2;
   v2 = v1mask;
   goto L7;
L6:;
   {
    cl_object v3element;
    v3element = ecl_car(v2);
    {
     cl_object v4;
     cl_object v5;
     v4 = ecl_symbol_value(VV[16]);
     v5 = si_make_seq_iterator(2, v4, ecl_make_fixnum(0));
L16:;
     if ((v5)!=ECL_NIL) { goto L18; }
     goto L13;
L18:;
     {
      cl_object v6;
      v6 = si_seq_iterator_ref(v4, v5);
      if (!(ecl_eql(v3element,v6))) { goto L20; }
      if ((v6)!=ECL_NIL) { goto L11; }
      goto L13;
     }
L20:;
     v5 = si_seq_iterator_next(v4, v5);
     goto L16;
    }
L13:;
    if ((ecl_gethash_safe(v3element,ecl_symbol_value(VV[7]),ECL_NIL))!=ECL_NIL) { goto L11; }
    goto L2;
L11:;
   }
   v2 = ecl_cdr(v2);
L7:;
   if (Null(v2)) { goto L27; }
   goto L6;
L27:;
   goto L1;
  }
L2:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[78])(2, v1mask, VV[17]) /*  X-TYPE-ERROR */;
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function MERGE-KEYSYM-MAPPINGS                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC9merge_keysym_mappings(cl_object v1new, cl_object v2old)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3key;
   cl_object v4merge;
   v3key = ecl_cadddr(v1new);
   T0 = (ECL_SYM("CADDDR",176)->symbol.gfdef);
   T1 = (ECL_SYM("EQUAL",335)->symbol.gfdef);
   v4merge = cl_delete(6, v3key, v2old, ECL_SYM("KEY",1265), T0, ECL_SYM("TEST",1319), T1);
   if (Null(v3key)) { goto L5; }
   T0 = ecl_list1(v1new);
   value0 = ecl_nconc(v4merge,T0);
   cl_env_copy->nvalues = 1;
   return value0;
L5:;
   value0 = CONS(v1new,v4merge);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for UNDEFINE-KEYSYM                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L13undefine_keysym(cl_narg narg, cl_object v1object, cl_object v2keysym, ...)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 {
  unsigned int v3keysym;
  cl_object v4display;
  cl_object v5modifiers;
  ecl_va_list args; ecl_va_start(args,v2keysym,narg,2);
  v3keysym = ecl_to_uint(v2keysym);
  {
   cl_object keyvars[4];
   cl_parse_key(args,2,L13undefine_keysymkeys,keyvars,NULL,TRUE);
   ecl_va_end(args);
   v4display = keyvars[0];
   v5modifiers = keyvars[1];
  }
  {
   cl_object v6;
   v6 = ecl_make_cfun((cl_objectfn_fixed)LC12match,ECL_NIL,Cblock,2);
   {
    cl_object v7entry;
    cl_object v8previous;
    cl_object v9key;
    v7entry = ECL_NIL;
    if (Null(v4display)) { goto L3; }
    T0 = ecl_function_dispatch(cl_env_copy,VV[77])(1, v4display) /*  DISPLAY-KEYSYM-TRANSLATION */;
    v7entry = ecl_assql(ecl_make_uint(v3keysym),T0);
    v8previous = ecl_cdr(v7entry);
    goto L2;
L3:;
    v8previous = ecl_gethash_safe(ecl_make_uint(v3keysym),ecl_symbol_value(VV[7]),ECL_NIL);
L2:;
    v9key = CONS(v1object,v5modifiers);
    if (Null(v8previous)) { goto L7; }
    {
     cl_object v10;
     v10 = si_make_seq_iterator(2, v8previous, ecl_make_fixnum(0));
L11:;
     if ((v10)!=ECL_NIL) { goto L13; }
     goto L7;
L13:;
     {
      cl_object v11;
      v11 = si_seq_iterator_ref(v8previous, v10);
      if (Null(LC12match(v9key, v11))) { goto L15; }
      if (Null(v11)) { goto L7; }
      goto L8;
     }
L15:;
     v10 = si_seq_iterator_next(v8previous, v10);
     goto L11;
    }
L8:;
    v8previous = cl_delete(4, v9key, v8previous, ECL_SYM("TEST",1319), v6);
    if (Null(v4display)) { goto L22; }
    {
     cl_object v10;
     v10 = v8previous;
     {
      cl_object v11;
      v11 = v7entry;
      if (ecl_unlikely(ECL_ATOM(v11))) FEtype_error_cons(v11);
      T0 = v11;
     }
     (ECL_CONS_CDR(T0)=v10,T0);
     value0 = v10;
     cl_env_copy->nvalues = 1;
     return value0;
    }
L22:;
    value0 = si_hash_set(ecl_make_uint(v3keysym), ecl_symbol_value(VV[7]), v8previous);
    return value0;
L7:;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      local function MATCH                                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC12match(cl_object v1key, cl_object v2entry)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = ecl_car(v1key);
   v4 = ecl_cdr(v1key);
   T0 = ecl_car(v2entry);
   value0 = ecl_make_bool(ecl_eql(v3,T0));
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_cadddr(v2entry);
   value0 = ecl_make_bool(ecl_equal(v4,T0));
   cl_env_copy->nvalues = 1;
   return value0;
L4:;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYSYM-DOWNCASE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L14keysym_downcase(cl_object v1keysym)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v2keysym;
  v2keysym = ecl_to_uint(v1keysym);
TTL:
  {
   cl_object v3translations;
   v3translations = ecl_gethash_safe(ecl_make_uint(v2keysym),ecl_symbol_value(VV[7]),ECL_NIL);
   if (Null(v3translations)) { goto L6; }
   T0 = ecl_car(v3translations);
   value0 = ecl_caddr(T0);
   goto L4;
L6:;
   value0 = ECL_NIL;
   goto L4;
L4:;
   if ((value0)!=ECL_NIL) { goto L3; }
   value0 = ecl_make_uint(v2keysym);
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYSYM-UPPERCASE-ALPHABETIC-P         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L15keysym_uppercase_alphabetic_p(cl_object v1keysym)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v2keysym;
  v2keysym = ecl_to_uint(v1keysym);
TTL:
  {
   cl_object v3translations;
   v3translations = ecl_gethash_safe(ecl_make_uint(v2keysym),ecl_symbol_value(VV[7]),ECL_NIL);
   if (Null(v3translations)) { goto L3; }
   T0 = ecl_car(v3translations);
   value0 = ecl_caddr(T0);
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for CHARACTER->KEYSYMS                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L17character__keysyms(cl_narg narg, cl_object v1character, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2display;
  va_list args; va_start(args,v1character);
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1character,env0);           /*  CHARACTER       */
  {
   int i = 1;
   if (i >= narg) {
    v2display = ECL_NIL;
   } else {
    i++;
    v2display = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object env1 = env0;
   CLV1 = env1 = CONS(ECL_NIL,env1);              /*  RESULT          */
   if (Null(v2display)) { goto L2; }
   {
    cl_object v3;
    v3 = ecl_function_dispatch(cl_env_copy,VV[77])(1, v2display) /*  DISPLAY-KEYSYM-TRANSLATION */;
    goto L7;
L6:;
    {
     cl_object v4mapping;
     v4mapping = ecl_car(v3);
     T0 = ecl_cadr(v4mapping);
     if (!(ecl_eql(ECL_CONS_CAR(CLV0),T0))) { goto L11; }
     T0 = ecl_car(v4mapping);
     ECL_CONS_CAR(CLV1) = CONS(T0,ECL_CONS_CAR(CLV1));
L11:;
    }
    v3 = ecl_cdr(v3);
L7:;
    if (Null(v3)) { goto L16; }
    goto L6;
L16:;
   }
L2:;
   {
    cl_object v3;
    v3 = ecl_make_cclosure_va((cl_objectfn)LC16__g124,env1,Cblock);
    T0 = v3;
   }
   cl_maphash(T0, ecl_symbol_value(VV[7]));
   value0 = ECL_CONS_CAR(CLV1);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure G124                                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC16__g124(cl_narg narg, cl_object v1keysym, cl_object v2mappings, ...)
{
 cl_object T0;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  RESULT          */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=2)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v3;
   v3 = v2mappings;
   goto L4;
L3:;
   {
    cl_object v4mapping;
    v4mapping = ecl_car(v3);
    T0 = ecl_car(v4mapping);
    if (!(ecl_eql(T0,ECL_CONS_CAR(CLV0)))) { goto L8; }
    ECL_CONS_CAR(CLV1) = cl_adjoin(2, v1keysym, ECL_CONS_CAR(CLV1));
L8:;
   }
   v3 = ecl_cdr(v3);
L4:;
   if (Null(v3)) { goto L13; }
   goto L3;
L13:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      function definition for DISPLAY-KEYBOARD-MAPPING              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L18display_keyboard_mapping(cl_object v1display)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[86])(1, v1display) /*  DISPLAY-KEYSYM-MAPPING */;
  if ((value0)!=ECL_NIL) { goto L2; }
  {
   cl_object v2;
   v2 = ecl_function_dispatch(cl_env_copy,VV[87])(1, v1display) /*  KEYBOARD-MAPPING */;
   value0 = ecl_structure_set(v1display,VV[19],53,v2);
   cl_env_copy->nvalues = 1;
   return value0;
  }
L2:;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for KEYCODE->KEYSYM                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L19keycode__keysym(cl_object v1display, cl_object v2keycode, cl_object v3keysym_index)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  uint8_t v4keycode;
  uint8_t v5keysym_index;
  v4keycode = ecl_to_uint8_t(v2keycode);
  v5keysym_index = ecl_to_uint8_t(v3keysym_index);
TTL:
  {
   cl_object v6mapping;
   unsigned int v7keysym;
   {
    cl_object v8;
    v8 = L18display_keyboard_mapping(v1display);
    T0 = cl_typep(2, v8, VV[41]);
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[41],v8);
    v6mapping = v8;
   }
   {
    cl_object v8;
    v8 = v6mapping;
    T0 = v8;
    {
     cl_fixnum v9;
     {
      cl_fixnum v10dim183;
      cl_fixnum v11dim184;
      cl_fixnum v12;
      v10dim183 = (v8)->array.dims[0];
      v11dim184 = (v8)->array.dims[1];
      v12 = 0;
      if (ecl_unlikely((v8)->array.rank != (2)))
            FEwrong_dimensions(v8,2);
      {
       cl_fixnum v13;
       v13 = (cl_fixnum)(v4keycode);
       if (ecl_unlikely((v13)>=(v10dim183)))
           FEwrong_index(ECL_NIL,v8,-1,ecl_make_fixnum(v13),v10dim183);
       v12 = (v12)+(v13);
      }
      v12 = (v12)*(v11dim184);
      {
       cl_fixnum v13;
       v13 = (cl_fixnum)(v5keysym_index);
       if (ecl_unlikely((v13)>=(v11dim184)))
           FEwrong_index(ECL_NIL,v8,-1,ecl_make_fixnum(v13),v11dim184);
       v12 = (v12)+(v13);
      }
      v9 = v12;
     }
     v7keysym = (unsigned int)((T0)->vector.self.b32[v9]);
    }
   }
   if (!(((cl_fixnum)(v5keysym_index))==0)) { goto L22; }
   value0 = L14keysym_downcase(ecl_make_uint(v7keysym));
   return value0;
L22:;
   if (!(ecl_zerop(ecl_make_uint(v7keysym)))) { goto L24; }
   if (!(((cl_fixnum)(v5keysym_index))>0)) { goto L24; }
   {
    cl_object v8;
    v8 = v6mapping;
    T0 = v8;
    {
     cl_fixnum v9;
     {
      cl_fixnum v10dim185;
      cl_fixnum v11dim186;
      cl_fixnum v12;
      v10dim185 = (v8)->array.dims[0];
      v11dim186 = (v8)->array.dims[1];
      v12 = 0;
      if (ecl_unlikely((v8)->array.rank != (2)))
            FEwrong_dimensions(v8,2);
      {
       cl_fixnum v13;
       v13 = (cl_fixnum)(v4keycode);
       if (ecl_unlikely((v13)>=(v10dim185)))
           FEwrong_index(ECL_NIL,v8,-1,ecl_make_fixnum(v13),v10dim185);
       v12 = (v12)+(v13);
      }
      v12 = (v12)*(v11dim186);
      {
       cl_fixnum v13;
       v13 = 0;
       if (ecl_unlikely((v13)>=(v11dim186)))
           FEwrong_index(ECL_NIL,v8,-1,ecl_make_fixnum(v13),v11dim186);
       v12 = (v12)+(v13);
      }
      v9 = v12;
     }
     value0 = ecl_make_uint32_t((T0)->vector.self.b32[v9]);
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
L24:;
   value0 = ecl_make_uint(v7keysym);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYSYM->CHARACTER                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L20keysym__character(cl_narg narg, cl_object v1display, cl_object v2keysym, ...)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>3)) FEwrong_num_arguments_anonym();
 {
  unsigned int v3keysym;
  cl_fixnum v4state;
  va_list args; va_start(args,v2keysym);
  v3keysym = ecl_to_uint(v2keysym);
  {
   int i = 2;
   if (i >= narg) {
    v4state = 0;
   } else {
    i++;
    v4state = ecl_to_fixnum(va_arg(args,cl_object));
   }
  }
  va_end(args);
  {
   cl_object v5display_mappings;
   cl_object v6mapping;
   T1 = ecl_function_dispatch(cl_env_copy,VV[77])(1, v1display) /*  DISPLAY-KEYSYM-TRANSLATION */;
   T0 = ecl_assql(ecl_make_uint(v3keysym),T1);
   v5display_mappings = ecl_cdr(T0);
   {
    cl_object v7;
    v7 = v5display_mappings;
    goto L11;
L10:;
    {
     cl_object v8mapping;
     v8mapping = ecl_car(v7);
     if (Null(L22mapping_matches_p(v1display, ecl_make_fixnum(v4state), v8mapping))) { goto L15; }
     value0 = v8mapping;
     goto L7;
L15:;
    }
    v7 = ecl_cdr(v7);
L11:;
    if (Null(v7)) { goto L19; }
    goto L10;
L19:;
    value0 = ECL_NIL;
   }
L7:;
   if ((value0)!=ECL_NIL) { goto L6; }
   {
    cl_object v7;
    v7 = ecl_gethash_safe(ecl_make_uint(v3keysym),ecl_symbol_value(VV[7]),ECL_NIL);
    goto L24;
L23:;
    {
     cl_object v8mapping;
     v8mapping = ecl_car(v7);
     if (Null(L22mapping_matches_p(v1display, ecl_make_fixnum(v4state), v8mapping))) { goto L28; }
     v6mapping = v8mapping;
     goto L4;
L28:;
    }
    v7 = ecl_cdr(v7);
L24:;
    if (Null(v7)) { goto L32; }
    goto L23;
L32:;
    v6mapping = ECL_NIL;
    goto L4;
   }
L6:;
   v6mapping = value0;
   goto L4;
L4:;
   if (Null(v6mapping)) { goto L34; }
   {
    cl_object v7;
    v7 = ecl_cadr(v6mapping);
    if (Null(v7)) { goto L38; }
    T0 = v7;
    goto L36;
L38:;
    T0 = VV[43];
   }
L36:;
   T1 = ecl_car(v6mapping);
   value0 = ecl_function_dispatch(cl_env_copy,T0)(3, v1display, ecl_make_fixnum(v4state), T1);
   return value0;
L34:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for MAPPING-MATCHES-P                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L22mapping_matches_p(cl_object v1display, cl_object v2state, cl_object v3mapping)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_fixnum v4state;
  v4state = ecl_to_fixnum(v2state);
TTL:
  {
   cl_object v5display_mapping;
   cl_object v6mapping_modifiers;
   cl_fixnum v7modifiers;
   cl_object v8mapping_mask;
   cl_fixnum v9mask;
   v5display_mapping = L27get_display_modifier_mapping(v1display);
   v6mapping_modifiers = ecl_cadddr(v3mapping);
   {
    cl_object v10;
    value0 = v6mapping_modifiers;
    if ((value0)!=ECL_NIL) { goto L10; }
    T0 = ecl_make_fixnum(0);
    goto L8;
L10:;
    T0 = value0;
    goto L8;
L8:;
    value0 = LC21modifiers__mask(v5display_mapping, T0, ECL_T);
    if ((value0)!=ECL_NIL) { goto L6; }
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
L6:;
    v10 = value0;
    goto L4;
L4:;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L16; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(65535))) { goto L21; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L13;
L21:;
     T0 = ECL_NIL;
     goto L13;
L16:;
     T0 = ECL_NIL;
     goto L13;
    }
L13:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[45],v10);
    v7modifiers = ecl_fixnum(v10);
   }
   T0 = ecl_cddddr(v3mapping);
   value0 = ecl_car(T0);
   if ((value0)!=ECL_NIL) { goto L25; }
   if (Null(v6mapping_modifiers)) { goto L27; }
   v8mapping_mask = ecl_symbol_value(VV[13]);
   goto L23;
L27:;
   v8mapping_mask = ecl_make_fixnum(0);
   goto L23;
L25:;
   v8mapping_mask = value0;
   goto L23;
L23:;
   {
    cl_object v10;
    if (!((v8mapping_mask)==(VV[15]))) { goto L31; }
    v10 = ecl_make_fixnum(v7modifiers);
    goto L30;
L31:;
    v10 = LC21modifiers__mask(v5display_mapping, v8mapping_mask, ECL_NIL);
L30:;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L37; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(65535))) { goto L42; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L34;
L42:;
     T0 = ECL_NIL;
     goto L34;
L37:;
     T0 = ECL_NIL;
     goto L34;
    }
L34:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[45],v10);
    v9mask = ecl_fixnum(v10);
   }
   {
    cl_fixnum v10;
    v10 = ((v4state) & (v9mask));
    value0 = ecl_make_bool((v10)==(v7modifiers));
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      local function MODIFIERS->MASK                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC21modifiers__mask(cl_object v1display_mapping, cl_object v2modifiers, cl_object v3errorp)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_fixnum v4mask;
   v4mask = 0;
   if (!(ecl_numberp(v2modifiers))) { goto L3; }
   value0 = v2modifiers;
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   {
    cl_object v5;
    v5 = v2modifiers;
    goto L8;
L7:;
    {
     cl_object v6modifier;
     {
      cl_object v7;
      v7 = ecl_car(v5);
      {
       bool v8;
       v8 = ECL_SYMBOLP(v7);
       if (ecl_unlikely(!(v8)))
         FEwrong_type_argument(ECL_SYM("SYMBOL",840),v7);
      }
      v6modifier = v7;
     }
     {
      cl_object v7bit;
      {
       cl_object v8;
       v8 = ecl_symbol_value(VV[16]);
       T1 = cl_simple_vector_p(v8);
       if (ecl_unlikely(!((T1)!=ECL_NIL)))
         FEwrong_type_argument(ECL_SYM("SIMPLE-VECTOR",774),v8);
       T0 = v8;
      }
      T1 = (ECL_SYM("EQ",333)->symbol.gfdef);
      v7bit = cl_position(4, v6modifier, T0, ECL_SYM("TEST",1319), T1);
      {
       cl_object v8;
       if (Null(v7bit)) { goto L23; }
       T0 = cl_ash(ecl_make_fixnum(1), v7bit);
       goto L22;
L23:;
       T1 = ecl_assql(v6modifier,v1display_mapping);
       value0 = ecl_cdr(T1);
       if ((value0)!=ECL_NIL) { goto L26; }
       if (Null(v3errorp)) { goto L29; }
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 1;
       return value0;
L29:;
       T0 = ecl_make_fixnum(0);
       goto L22;
L26:;
       T0 = value0;
       goto L22;
L22:;
       v8 = ecl_boole(ECL_BOOLIOR,(ecl_make_fixnum(v4mask)),(T0));
       {
        cl_fixnum v9;
        v9 = 0;
        if (!(ECL_FIXNUMP(v8))) { goto L35; }
        v9 = ecl_fixnum(v8);
        if (!((v9)<=(65535))) { goto L40; }
        T0 = ecl_make_bool((v9)>=(0));
        goto L32;
L40:;
        T0 = ECL_NIL;
        goto L32;
L35:;
        T0 = ECL_NIL;
        goto L32;
       }
L32:;
       if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[45],v8);
       v4mask = ecl_fixnum(v8);
      }
     }
    }
    v5 = ecl_cdr(v5);
L8:;
    if (Null(v5)) { goto L44; }
    goto L7;
L44:;
    value0 = ecl_make_fixnum(v4mask);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for DEFAULT-KEYSYM-INDEX                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L23default_keysym_index(cl_object v1display, cl_object v2keycode, cl_object v3state)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4mapping;
   uint8_t v5keysyms_per_keycode;
   cl_object v6symbolp;
   uint8_t v7result;
   {
    cl_object v8;
    v8 = L18display_keyboard_mapping(v1display);
    T0 = cl_typep(2, v8, VV[41]);
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[41],v8);
    v4mapping = v8;
   }
   {
    cl_fixnum v8;
    v8 = ecl_array_dimension(v4mapping,1);
    {
     cl_fixnum v9;
     v9 = 0;
     v9 = v8;
     if (!((v9)<=(255))) { goto L15; }
     T0 = ecl_make_bool((v9)>=(0));
     goto L7;
L15:;
     T0 = ECL_NIL;
     goto L7;
     T0 = ECL_NIL;
     goto L7;
    }
L7:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],ecl_make_fixnum(v8));
    v5keysyms_per_keycode = (uint8_t)(v8);
   }
   if (!(((cl_fixnum)(v5keysyms_per_keycode))>(2))) { goto L19; }
   v6symbolp = L28state_keysymp(v1display, v3state, ecl_make_fixnum(65406));
   goto L17;
L19:;
   v6symbolp = ECL_NIL;
   goto L17;
L17:;
   {
    cl_fixnum v8;
    if (Null(v6symbolp)) { goto L23; }
    v8 = 2;
    goto L22;
L23:;
    v8 = 0;
L22:;
    {
     cl_fixnum v9;
     v9 = 0;
     v9 = v8;
     if (!((v9)<=(255))) { goto L34; }
     T0 = ecl_make_bool((v9)>=(0));
     goto L26;
L34:;
     T0 = ECL_NIL;
     goto L26;
     T0 = ECL_NIL;
     goto L26;
    }
L26:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],ecl_make_fixnum(v8));
    v7result = (uint8_t)(v8);
   }
   if (!(((cl_fixnum)(v7result))<((cl_fixnum)(v5keysyms_per_keycode)))) { goto L36; }
   {
    unsigned int v8;
    {
     cl_object v9;
     v9 = v4mapping;
     T0 = v9;
     {
      cl_fixnum v10;
      {
       cl_fixnum v11dim187;
       cl_fixnum v12dim188;
       cl_fixnum v13;
       v11dim187 = (v9)->array.dims[0];
       v12dim188 = (v9)->array.dims[1];
       v13 = 0;
       if (ecl_unlikely((v9)->array.rank != (2)))
            FEwrong_dimensions(v9,2);
       {
        cl_fixnum v14;
        v14 = ecl_fixnum(v2keycode);
        if (ecl_unlikely((v14)>=(v11dim187)))
           FEwrong_index(ECL_NIL,v9,-1,ecl_make_fixnum(v14),v11dim187);
        v13 = (v13)+(v14);
       }
       v13 = (v13)*(v12dim188);
       {
        cl_fixnum v14;
        v14 = 0;
        if (ecl_unlikely((v14)>=(v12dim188)))
           FEwrong_index(ECL_NIL,v9,-1,ecl_make_fixnum(v14),v12dim188);
        v13 = (v13)+(v14);
       }
       v10 = v13;
      }
      v8 = (unsigned int)((T0)->vector.self.b32[v10]);
     }
    }
    T0 = L15keysym_uppercase_alphabetic_p(ecl_make_uint(v8));
    if (Null(L24keysym_shift_p(3, v1display, v3state, T0))) { goto L36; }
   }
   {
    cl_object v8;
    v8 = ecl_plus(ecl_make_uint8_t(v7result),ecl_make_fixnum(1));
    {
     cl_fixnum v9;
     v9 = 0;
     if (!(ECL_FIXNUMP(v8))) { goto L63; }
     v9 = ecl_fixnum(v8);
     if (!((v9)<=(255))) { goto L68; }
     T0 = ecl_make_bool((v9)>=(0));
     goto L60;
L68:;
     T0 = ECL_NIL;
     goto L60;
L63:;
     T0 = ECL_NIL;
     goto L60;
    }
L60:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v8);
    v7result = ecl_fixnum(v8);
   }
L36:;
   value0 = ecl_make_uint8_t(v7result);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYSYM-SHIFT-P                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L24keysym_shift_p(cl_narg narg, cl_object v1display, cl_object v2state, cl_object v3uppercase_alphabetic_p, ...)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 {
  cl_fixnum v4state;
  cl_object v5shift_lock_xors;
  cl_object v6control_modifiers;
  ecl_va_list args; ecl_va_start(args,v3uppercase_alphabetic_p,narg,3);
  v4state = ecl_to_fixnum(v2state);
  {
   cl_object keyvars[4];
   cl_parse_key(args,2,L24keysym_shift_pkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v5shift_lock_xors = keyvars[0];
   if (Null(keyvars[3])) {
    v6control_modifiers = VV[49];
   } else {
    v6control_modifiers = keyvars[1];
   }
  }
  {
   cl_object v7controlp;
   cl_object v8shiftp;
   cl_object v9lockp;
   cl_object v10alphap;
   value0 = cl_logbitp(ecl_make_fixnum(2), ecl_make_fixnum(v4state));
   if ((value0)!=ECL_NIL) { goto L4; }
   {
    cl_object v11;
    v11 = v6control_modifiers;
    goto L9;
L8:;
    {
     cl_object v12modifier;
     v12modifier = ecl_car(v11);
     if (Null(L28state_keysymp(v1display, ecl_make_fixnum(v4state), v12modifier))) { goto L13; }
     v7controlp = ECL_T;
     goto L2;
L13:;
    }
    v11 = ecl_cdr(v11);
L9:;
    if (Null(v11)) { goto L17; }
    goto L8;
L17:;
    v7controlp = ECL_NIL;
    goto L2;
   }
L4:;
   v7controlp = value0;
   goto L2;
L2:;
   v8shiftp = cl_logbitp(ecl_make_fixnum(0), ecl_make_fixnum(v4state));
   v9lockp = cl_logbitp(ecl_make_fixnum(1), ecl_make_fixnum(v4state));
   value0 = v3uppercase_alphabetic_p;
   if ((value0)!=ECL_NIL) { goto L23; }
   T0 = L28state_keysymp(v1display, ecl_make_fixnum(2), ecl_make_fixnum(65509));
   v10alphap = Null(T0)?ECL_T:ECL_NIL;
   goto L21;
L23:;
   v10alphap = value0;
   goto L21;
L21:;
   if ((v7controlp)!=ECL_NIL) { goto L25; }
   if (Null(v9lockp)) { goto L25; }
   if (Null(v10alphap)) { goto L25; }
   if (Null(v8shiftp)) { goto L30; }
   if (Null(v5shift_lock_xors)) { goto L25; }
   goto L27;
L30:;
L27:;
   v8shiftp = Null(v8shiftp)?ECL_T:ECL_NIL;
L25:;
   value0 = v8shiftp;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYCODE->CHARACTER                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L25keycode__character(cl_narg narg, cl_object v1display, cl_object v2keycode, cl_object v3state, ...)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 {
  uint8_t v4keycode;
  cl_fixnum v5state;
  cl_object v6keysym_index;
  cl_object v7keysym_index_function;
  ecl_va_list args; ecl_va_start(args,v3state,narg,3);
  v4keycode = ecl_to_uint8_t(v2keycode);
  v5state = ecl_to_fixnum(v3state);
  {
   cl_object keyvars[4];
   cl_parse_key(args,2,L25keycode__characterkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v6keysym_index = keyvars[0];
   if (Null(keyvars[3])) {
    v7keysym_index_function = ecl_fdefinition(VV[48]);
   } else {
    v7keysym_index_function = keyvars[1];
   }
  }
  {
   cl_object v8index;
   unsigned int v9keysym;
   {
    cl_object v10;
    value0 = v6keysym_index;
    if ((value0)!=ECL_NIL) { goto L5; }
    v10 = ecl_function_dispatch(cl_env_copy,v7keysym_index_function)(3, v1display, ecl_make_uint8_t(v4keycode), ecl_make_fixnum(v5state));
    goto L3;
L5:;
    v10 = value0;
    goto L3;
L3:;
    value0 = ecl_make_bool(v10==ECL_NIL);
    if ((value0)!=ECL_NIL) { goto L10; }
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L14; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L19; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L8;
L19:;
     T0 = ECL_NIL;
     goto L8;
L14:;
     T0 = ECL_NIL;
     goto L8;
    }
L10:;
    T0 = value0;
    goto L8;
L8:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[51],v10);
    v8index = v10;
   }
   {
    cl_object v10;
    if (Null(v8index)) { goto L23; }
    v10 = L19keycode__keysym(v1display, ecl_make_uint8_t(v4keycode), v8index);
    goto L22;
L23:;
    v10 = ecl_make_fixnum(0);
L22:;
    {
     cl_object v11;
     v11 = ecl_make_fixnum(0);
     if (!(ECL_FIXNUMP(v10)||ECL_BIGNUMP(v10))) { goto L29; }
     v11 = v10;
     if (!(ecl_number_compare(v11,VV[1])<=0)) { goto L34; }
     T0 = ecl_make_bool(ecl_number_compare(v11,ecl_make_fixnum(0))>=0);
     goto L26;
L34:;
     T0 = ECL_NIL;
     goto L26;
L29:;
     T0 = ECL_NIL;
     goto L26;
    }
L26:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[2],v10);
    v9keysym = ecl_to_uint(v10);
   }
   if (!(ecl_plusp(ecl_make_uint(v9keysym)))) { goto L36; }
   value0 = L20keysym__character(3, v1display, ecl_make_uint(v9keysym), ecl_make_fixnum(v5state));
   return value0;
L36:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GET-DISPLAY-MODIFIER-MAPPING          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L27get_display_modifier_mapping(cl_object v1display)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[99])(1, v1display) /*  DISPLAY-MODIFIER-MAPPING */;
  if ((value0)!=ECL_NIL) { goto L2; }
  {
   cl_object v3;                                  /*  SHIFT           */
   cl_object v4;                                  /*  LOCK            */
   cl_object v5;                                  /*  CONTROL         */
   cl_object v6;                                  /*  MOD1            */
   cl_object v7;                                  /*  MOD2            */
   cl_object v8;                                  /*  MOD3            */
   cl_object v9;                                  /*  MOD4            */
   cl_object v10;                                 /*  MOD5            */
   value0 = ecl_function_dispatch(cl_env_copy,VV[100])(1, v1display) /*  MODIFIER-MAPPING */;
   v3 = value0;
   {
    const int v11 = cl_env_copy->nvalues;
    cl_object v12;
    v12 = (v11<=1)? ECL_NIL : cl_env_copy->values[1];
    v4 = v12;
    v12 = (v11<=2)? ECL_NIL : cl_env_copy->values[2];
    v5 = v12;
    v12 = (v11<=3)? ECL_NIL : cl_env_copy->values[3];
    v6 = v12;
    v12 = (v11<=4)? ECL_NIL : cl_env_copy->values[4];
    v7 = v12;
    v12 = (v11<=5)? ECL_NIL : cl_env_copy->values[5];
    v8 = v12;
    v12 = (v11<=6)? ECL_NIL : cl_env_copy->values[6];
    v9 = v12;
    v12 = (v11<=7)? ECL_NIL : cl_env_copy->values[7];
    v10 = v12;
   }
   {
    cl_object v11;
    T0 = LC26keysym_replace(v1display, v3, ecl_make_fixnum(1));
    T1 = LC26keysym_replace(v1display, v4, ecl_make_fixnum(2));
    T2 = LC26keysym_replace(v1display, v5, ecl_make_fixnum(4));
    T3 = LC26keysym_replace(v1display, v6, ecl_make_fixnum(8));
    T4 = LC26keysym_replace(v1display, v7, ecl_make_fixnum(16));
    T5 = LC26keysym_replace(v1display, v8, ecl_make_fixnum(32));
    T6 = LC26keysym_replace(v1display, v9, ecl_make_fixnum(64));
    T7 = LC26keysym_replace(v1display, v10, ecl_make_fixnum(128));
    v11 = cl_nconc(8, T0, T1, T2, T3, T4, T5, T6, T7);
    value0 = ecl_structure_set(v1display,VV[19],54,v11);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
L2:;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function KEYSYM-REPLACE                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC26keysym_replace(cl_object v1display, cl_object v2modifiers, cl_object v3mask)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4result;
   v4result = ECL_NIL;
   {
    cl_object v5;
    v5 = v2modifiers;
    goto L5;
L4:;
    {
     cl_object v6modifier;
     v6modifier = ecl_car(v5);
     T0 = L19keycode__keysym(v1display, v6modifier, ecl_make_fixnum(0));
     T1 = CONS(T0,v3mask);
     v4result = CONS(T1,v4result);
    }
    v5 = ecl_cdr(v5);
L5:;
    if (Null(v5)) { goto L13; }
    goto L4;
L13:;
    value0 = v4result;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for STATE-KEYSYMP                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L28state_keysymp(cl_object v1display, cl_object v2state, cl_object v3keysym)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_fixnum v4state;
  unsigned int v5keysym;
  v4state = ecl_to_fixnum(v2state);
  v5keysym = ecl_to_uint(v3keysym);
TTL:
  {
   cl_object v6mapping;
   cl_object v7mask;
   v6mapping = L27get_display_modifier_mapping(v1display);
   v7mask = ecl_assql(ecl_make_uint(v5keysym),v6mapping);
   if (Null(v7mask)) { goto L4; }
   T0 = ecl_cdr(v7mask);
   T1 = ecl_boole(ECL_BOOLAND,(ecl_make_fixnum(v4state)),(T0));
   value0 = ecl_make_bool(ecl_plusp(T1));
   cl_env_copy->nvalues = 1;
   return value0;
L4:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for MAPPING-NOTIFY                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L29mapping_notify(cl_object v1display, cl_object v2request, cl_object v3start, cl_object v4count)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!((v2request)==(VV[55]))) { goto L1; }
  value0 = ecl_structure_set(v1display,VV[19],54,ECL_NIL);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (!((v2request)==(VV[56]))) { goto L3; }
  value0 = ecl_structure_set(v1display,VV[19],53,ECL_NIL);
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for KEYSYM-IN-MAP-P                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L30keysym_in_map_p(cl_object v1display, cl_object v2keysym, cl_object v3keymap)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v4keysym;
  v4keysym = ecl_to_uint(v2keysym);
TTL:
  {
   uint8_t v5min;
   uint8_t v6max;
   cl_object v7map;
   uint8_t v8jmax;
   cl_object v9i;
   {
    cl_object v10;
    v10 = ecl_function_dispatch(cl_env_copy,VV[104])(1, v1display) /*  DISPLAY-MIN-KEYCODE */;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L7; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L12; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L4;
L12:;
     T0 = ECL_NIL;
     goto L4;
L7:;
     T0 = ECL_NIL;
     goto L4;
    }
L4:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v5min = ecl_fixnum(v10);
   }
   {
    cl_object v10;
    v10 = ecl_function_dispatch(cl_env_copy,VV[105])(1, v1display) /*  DISPLAY-MAX-KEYCODE */;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L20; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L25; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L17;
L25:;
     T0 = ECL_NIL;
     goto L17;
L20:;
     T0 = ECL_NIL;
     goto L17;
    }
L17:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v6max = ecl_fixnum(v10);
   }
   {
    cl_object v10;
    v10 = L18display_keyboard_mapping(v1display);
    T0 = cl_typep(2, v10, VV[41]);
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[41],v10);
    v7map = v10;
   }
   {
    cl_object v10;
    {
     cl_fixnum v11;
     v11 = ecl_array_dimension(v7map,1);
     v10 = ecl_make_fixnum((2)<=(v11)?2:v11);
    }
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L36; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L41; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L33;
L41:;
     T0 = ECL_NIL;
     goto L33;
L36:;
     T0 = ECL_NIL;
     goto L33;
    }
L33:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v8jmax = ecl_fixnum(v10);
   }
   v9i = ecl_make_uint8_t(v5min);
   goto L46;
L45:;
   {
    int8_t v10;
    {
     cl_object v11;
     v11 = v3keymap;
     T0 = v11;
     {
      cl_fixnum v12;
      {
       cl_object v13;
       v13 = v9i;
       if (ecl_unlikely((ecl_fixnum(v13))>=(v11)->vector.dim))
           FEwrong_index(ECL_NIL,v11,-1,ecl_make_fixnum(ecl_fixnum(v13)),(v11)->vector.dim);
       v12 = ecl_fixnum(v13);
      }
      v10 = (int8_t)(ecl_aref_bv(T0,v12));
     }
    }
    if (!(((cl_fixnum)(v10))>0)) { goto L48; }
   }
   {
    cl_fixnum v10j;
    v10j = 0;
    goto L59;
L58:;
    {
     unsigned int v11;
     {
      cl_object v12;
      v12 = v7map;
      T0 = v12;
      {
       cl_fixnum v13;
       {
        cl_fixnum v14dim189;
        cl_fixnum v15dim190;
        cl_fixnum v16;
        v14dim189 = (v12)->array.dims[0];
        v15dim190 = (v12)->array.dims[1];
        v16 = 0;
        if (ecl_unlikely((v12)->array.rank != (2)))
            FEwrong_dimensions(v12,2);
        {
         cl_fixnum v17;
         v17 = ecl_fixnum(v9i);
         if (ecl_unlikely((v17)>=(v14dim189)))
           FEwrong_index(ECL_NIL,v12,-1,ecl_make_fixnum(v17),v14dim189);
         v16 = (v16)+(v17);
        }
        v16 = (v16)*(v15dim190);
        {
         cl_fixnum v17;
         v17 = v10j;
         if (ecl_unlikely((v17)>=(v15dim190)))
           FEwrong_index(ECL_NIL,v12,-1,ecl_make_fixnum(v17),v15dim190);
         v16 = (v16)+(v17);
        }
        v13 = v16;
       }
       v11 = (unsigned int)((T0)->vector.self.b32[v13]);
      }
     }
     if (!(ecl_number_equalp(ecl_make_uint(v4keysym),ecl_make_uint(v11)))) { goto L61; }
    }
    goto L49;
L61:;
    v10j = (v10j)+1;
L59:;
    if (!((v10j)<((cl_fixnum)(v8jmax)))) { goto L83; }
    goto L58;
L83:;
    goto L48;
   }
L49:;
   value0 = ECL_T;
   cl_env_copy->nvalues = 1;
   return value0;
L48:;
   v9i = ecl_one_plus(v9i);
L46:;
   if (ecl_number_compare(v9i,ecl_make_uint8_t(v6max))>0) { goto L87; }
   goto L45;
L87:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for CHARACTER-IN-MAP-P                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L31character_in_map_p(cl_object v1display, cl_object v2character, cl_object v3keymap)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  ecl_character v4character;
  v4character = ecl_char_code(v2character);
TTL:
  {
   uint8_t v5min;
   uint8_t v6max;
   uint8_t v7jmax;
   cl_object v8i;
   {
    cl_object v9;
    v9 = ecl_function_dispatch(cl_env_copy,VV[104])(1, v1display) /*  DISPLAY-MIN-KEYCODE */;
    {
     cl_fixnum v10;
     v10 = 0;
     if (!(ECL_FIXNUMP(v9))) { goto L7; }
     v10 = ecl_fixnum(v9);
     if (!((v10)<=(255))) { goto L12; }
     T0 = ecl_make_bool((v10)>=(0));
     goto L4;
L12:;
     T0 = ECL_NIL;
     goto L4;
L7:;
     T0 = ECL_NIL;
     goto L4;
    }
L4:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v9);
    v5min = ecl_fixnum(v9);
   }
   {
    cl_object v9;
    v9 = ecl_function_dispatch(cl_env_copy,VV[105])(1, v1display) /*  DISPLAY-MAX-KEYCODE */;
    {
     cl_fixnum v10;
     v10 = 0;
     if (!(ECL_FIXNUMP(v9))) { goto L20; }
     v10 = ecl_fixnum(v9);
     if (!((v10)<=(255))) { goto L25; }
     T0 = ecl_make_bool((v10)>=(0));
     goto L17;
L25:;
     T0 = ECL_NIL;
     goto L17;
L20:;
     T0 = ECL_NIL;
     goto L17;
    }
L17:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v9);
    v6max = ecl_fixnum(v9);
   }
   {
    cl_fixnum v9;
    T0 = L18display_keyboard_mapping(v1display);
    v9 = ecl_array_dimension(T0,1);
    {
     cl_fixnum v10;
     v10 = 0;
     v10 = v9;
     if (!((v10)<=(255))) { goto L38; }
     T0 = ecl_make_bool((v10)>=(0));
     goto L30;
L38:;
     T0 = ECL_NIL;
     goto L30;
     T0 = ECL_NIL;
     goto L30;
    }
L30:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],ecl_make_fixnum(v9));
    v7jmax = (uint8_t)(v9);
   }
   v8i = ecl_make_uint8_t(v5min);
   goto L43;
L42:;
   {
    int8_t v9;
    {
     cl_object v10;
     v10 = v3keymap;
     T0 = v10;
     {
      cl_fixnum v11;
      {
       cl_object v12;
       v12 = v8i;
       if (ecl_unlikely((ecl_fixnum(v12))>=(v10)->vector.dim))
           FEwrong_index(ECL_NIL,v10,-1,ecl_make_fixnum(ecl_fixnum(v12)),(v10)->vector.dim);
       v11 = ecl_fixnum(v12);
      }
      v9 = (int8_t)(ecl_aref_bv(T0,v11));
     }
    }
    if (!(((cl_fixnum)(v9))>0)) { goto L45; }
   }
   {
    cl_fixnum v9j;
    v9j = 0;
    goto L56;
L55:;
    T0 = L25keycode__character(5, v1display, v8i, ecl_make_fixnum(0), VV[59], ecl_make_fixnum(v9j));
    if (!((ECL_CODE_CHAR(v4character)==(T0)))) { goto L58; }
    goto L46;
L58:;
    v9j = (v9j)+1;
L56:;
    if (!((v9j)<((cl_fixnum)(v7jmax)))) { goto L62; }
    goto L55;
L62:;
    goto L45;
   }
L46:;
   value0 = ECL_T;
   cl_env_copy->nvalues = 1;
   return value0;
L45:;
   v8i = ecl_one_plus(v8i);
L43:;
   if (ecl_number_compare(v8i,ecl_make_uint8_t(v6max))>0) { goto L66; }
   goto L42;
L66:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for KEYSYM->KEYCODES                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L32keysym__keycodes(cl_object v1display, cl_object v2keysym)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  unsigned int v3keysym;
  v3keysym = ecl_to_uint(v2keysym);
TTL:
  {
   uint8_t v4min;
   uint8_t v5max;
   cl_object v6map;
   uint8_t v7jmax;
   cl_object v8i;
   cl_object v9result;
   {
    cl_object v10;
    v10 = ecl_function_dispatch(cl_env_copy,VV[104])(1, v1display) /*  DISPLAY-MIN-KEYCODE */;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L7; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L12; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L4;
L12:;
     T0 = ECL_NIL;
     goto L4;
L7:;
     T0 = ECL_NIL;
     goto L4;
    }
L4:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v4min = ecl_fixnum(v10);
   }
   {
    cl_object v10;
    v10 = ecl_function_dispatch(cl_env_copy,VV[105])(1, v1display) /*  DISPLAY-MAX-KEYCODE */;
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L20; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L25; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L17;
L25:;
     T0 = ECL_NIL;
     goto L17;
L20:;
     T0 = ECL_NIL;
     goto L17;
    }
L17:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v5max = ecl_fixnum(v10);
   }
   {
    cl_object v10;
    v10 = L18display_keyboard_mapping(v1display);
    T0 = cl_typep(2, v10, VV[41]);
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[41],v10);
    v6map = v10;
   }
   {
    cl_object v10;
    {
     cl_fixnum v11;
     v11 = ecl_array_dimension(v6map,1);
     v10 = ecl_make_fixnum((2)<=(v11)?2:v11);
    }
    {
     cl_fixnum v11;
     v11 = 0;
     if (!(ECL_FIXNUMP(v10))) { goto L36; }
     v11 = ecl_fixnum(v10);
     if (!((v11)<=(255))) { goto L41; }
     T0 = ecl_make_bool((v11)>=(0));
     goto L33;
L41:;
     T0 = ECL_NIL;
     goto L33;
L36:;
     T0 = ECL_NIL;
     goto L33;
    }
L33:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[47],v10);
    v7jmax = ecl_fixnum(v10);
   }
   v8i = ecl_make_uint8_t(v4min);
   v9result = ECL_NIL;
   goto L47;
L46:;
   {
    cl_fixnum v10j;
    v10j = 0;
    goto L52;
L51:;
    {
     unsigned int v11;
     {
      cl_object v12;
      v12 = v6map;
      T0 = v12;
      {
       cl_fixnum v13;
       {
        cl_fixnum v14dim191;
        cl_fixnum v15dim192;
        cl_fixnum v16;
        v14dim191 = (v12)->array.dims[0];
        v15dim192 = (v12)->array.dims[1];
        v16 = 0;
        if (ecl_unlikely((v12)->array.rank != (2)))
            FEwrong_dimensions(v12,2);
        {
         cl_fixnum v17;
         v17 = ecl_fixnum(v8i);
         if (ecl_unlikely((v17)>=(v14dim191)))
           FEwrong_index(ECL_NIL,v12,-1,ecl_make_fixnum(v17),v14dim191);
         v16 = (v16)+(v17);
        }
        v16 = (v16)*(v15dim192);
        {
         cl_fixnum v17;
         v17 = v10j;
         if (ecl_unlikely((v17)>=(v15dim192)))
           FEwrong_index(ECL_NIL,v12,-1,ecl_make_fixnum(v17),v15dim192);
         v16 = (v16)+(v17);
        }
        v13 = v16;
       }
       v11 = (unsigned int)((T0)->vector.self.b32[v13]);
      }
     }
     if (!(ecl_number_equalp(ecl_make_uint(v3keysym),ecl_make_uint(v11)))) { goto L54; }
    }
    v9result = CONS(v8i,v9result);
L54:;
    v10j = (v10j)+1;
L52:;
    if (!((v10j)<((cl_fixnum)(v7jmax)))) { goto L77; }
    goto L51;
L77:;
   }
   v8i = ecl_one_plus(v8i);
L47:;
   if (ecl_number_compare(v8i,ecl_make_uint8_t(v5max))>0) { goto L81; }
   goto L46;
L81:;
   value0 = cl_values_list(v9result);
   return value0;
  }
 }
}

#include "clx/translate.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecl8iWkHba7_dX0VEX21(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = make_constant_base_string("SRC:CLX;TRANSLATE.LISP.NEWEST");
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecl8iWkHba7_dX0VEX21@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  si_Xmake_special(VV[0]);
  if (ecl_boundp(cl_env_copy,VV[0])) { goto L3; }
  cl_set(VV[0],ECL_NIL);
L3:;
  ecl_cmp_defun(VV[62]);                          /*  DEFINE-KEYSYM-SET */
  ecl_cmp_defun(VV[63]);                          /*  KEYSYM-SET      */
  ecl_cmp_defmacro(VV[64]);                       /*  KEYSYM          */
 {
  cl_object T0;
  si_Xmake_special(VV[7]);
  if (ecl_boundp(cl_env_copy,VV[7])) { goto L20; }
  T0 = (ECL_SYM("EQL",334)->symbol.gfdef);
  cl_set(VV[7],cl_make_hash_table(4, ECL_SYM("TEST",1319), T0, ECL_SYM("SIZE",1311), ecl_make_fixnum(400)));
L20:;
 }
  ecl_cmp_defmacro(VV[65]);                       /*  KEYSYM-MAPPING-OBJECT */
  ecl_cmp_defmacro(VV[66]);                       /*  KEYSYM-MAPPING-TRANSLATE */
  ecl_cmp_defmacro(VV[67]);                       /*  KEYSYM-MAPPING-LOWERCASE */
  ecl_cmp_defmacro(VV[68]);                       /*  KEYSYM-MAPPING-MODIFIERS */
  ecl_cmp_defmacro(VV[69]);                       /*  KEYSYM-MAPPING-MASK */
 {
  cl_object T0, T1;
  si_Xmake_special(VV[13]);
  if (ecl_boundp(cl_env_copy,VV[13])) { goto L38; }
  {
   cl_object v1;
   T0 = ecl_function_dispatch(cl_env_copy,VV[70])(1, VV[14]) /*  MAKE-STATE-MASK */;
   T1 = ecl_boole(ECL_BOOLXOR,(T0),ecl_make_fixnum(-1));
   v1 = ecl_boole(ECL_BOOLAND,(ecl_make_fixnum(255)),(T1));
   if (!(ecl_eql(v1,VV[15]))) { goto L48; }
   value0 = VVtemp[0];
   goto L46;
L48:;
   value0 = ECL_NIL;
   goto L46;
L46:;
   if ((value0)!=ECL_NIL) { goto L45; }
   {
    cl_fixnum v2;
    v2 = 0;
    if (!(ECL_FIXNUMP(v1))) { goto L53; }
    v2 = ecl_fixnum(v1);
    if (!((v2)<=(65535))) { goto L58; }
    value0 = ecl_make_bool((v2)>=(0));
    goto L50;
L58:;
    value0 = ECL_NIL;
    goto L50;
L53:;
    value0 = ECL_NIL;
    goto L50;
   }
L50:;
   if ((value0)!=ECL_NIL) { goto L45; }
   T0 = ecl_make_bool(ECL_LISTP(v1));
   goto L43;
L45:;
   T0 = value0;
   goto L43;
L43:;
   if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VVtemp[1],v1);
   cl_set(VV[13],v1);
  }
L38:;
 }
  ecl_cmp_defun(VV[71]);                          /*  DEFINE-KEYSYM   */
  ecl_cmp_defun(VV[79]);                          /*  UNDEFINE-KEYSYM */
  ecl_cmp_defun(VV[82]);                          /*  KEYSYM-DOWNCASE */
  ecl_cmp_defun(VV[83]);                          /*  KEYSYM-UPPERCASE-ALPHABETIC-P */
  ecl_cmp_defun(VV[84]);                          /*  CHARACTER->KEYSYMS */
  si_Xmake_constant(VV[25], ecl_make_fixnum(65406));
  si_Xmake_constant(VV[26], ecl_make_fixnum(65505));
  si_Xmake_constant(VV[27], ecl_make_fixnum(65506));
  si_Xmake_constant(VV[28], ecl_make_fixnum(65507));
  si_Xmake_constant(VV[29], ecl_make_fixnum(65508));
  si_Xmake_constant(VV[30], ecl_make_fixnum(65509));
  si_Xmake_constant(VV[31], ecl_make_fixnum(65510));
  si_Xmake_constant(VV[32], ecl_make_fixnum(65511));
  si_Xmake_constant(VV[33], ecl_make_fixnum(65512));
  si_Xmake_constant(VV[34], ecl_make_fixnum(65513));
  si_Xmake_constant(VV[35], ecl_make_fixnum(65514));
  si_Xmake_constant(VV[36], ecl_make_fixnum(65515));
  si_Xmake_constant(VV[37], ecl_make_fixnum(65516));
  si_Xmake_constant(VV[38], ecl_make_fixnum(65517));
  si_Xmake_constant(VV[39], ecl_make_fixnum(65518));
  ecl_cmp_defun(VV[85]);                          /*  DISPLAY-KEYBOARD-MAPPING */
  ecl_cmp_defun(VV[88]);                          /*  KEYCODE->KEYSYM */
  ecl_cmp_defun(VV[89]);                          /*  KEYSYM->CHARACTER */
  ecl_cmp_defun(VV[90]);                          /*  MAPPING-MATCHES-P */
  ecl_cmp_defun(VV[91]);                          /*  DEFAULT-KEYSYM-INDEX */
  ecl_cmp_defun(VV[92]);                          /*  KEYSYM-SHIFT-P  */
  ecl_cmp_defun(VV[95]);                          /*  KEYCODE->CHARACTER */
  ecl_cmp_defun(VV[98]);                          /*  GET-DISPLAY-MODIFIER-MAPPING */
  ecl_cmp_defun(VV[101]);                         /*  STATE-KEYSYMP   */
  ecl_cmp_defun(VV[102]);                         /*  MAPPING-NOTIFY  */
  ecl_cmp_defun(VV[103]);                         /*  KEYSYM-IN-MAP-P */
  ecl_cmp_defun(VV[106]);                         /*  CHARACTER-IN-MAP-P */
  ecl_cmp_defun(VV[107]);                         /*  KEYSYM->KEYCODES */
}
