/*      Compiler: ECL 16.0.0                                          */
/*      Source: SRC:CLX;MACROS.LISP                                   */
#include <ecl/ecl-cmp.h>
#include "clx/macros.eclh"
/*      local function TYPE-CHECK                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1type_check(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4value;
   cl_object v5type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4value = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5type = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(3, VV[0], v4value, v5type);
   T1 = cl_list(3, VV[1], v4value, v5type);
   value0 = cl_list(3, ECL_SYM("UNLESS",883), T0, T1);
   return value0;
  }
 }
}
/*      local function REQUIRED-ARG                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2required_arg(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4name;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4name = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, ECL_SYM("QUOTE",679), v4name);
   T1 = cl_list(4, VV[4], VV[5], VV[6], T0);
   value0 = cl_list(3, ECL_SYM("PROGN",671), T1, VV[3]);
   return value0;
  }
 }
}
/*      local function LROUND                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3lround(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(3, VV[9], v4index, ecl_make_fixnum(3));
   T1 = cl_list(3, ECL_SYM("LOGAND",492), T0, ecl_make_fixnum(-4));
   value0 = cl_list(3, ECL_SYM("THE",856), VV[8], T1);
   return value0;
  }
 }
}
/*      local function WROUND                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4wround(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(3, VV[9], v4index, ecl_make_fixnum(1));
   T1 = cl_list(3, ECL_SYM("LOGAND",492), T0, ecl_make_fixnum(-2));
   value0 = cl_list(3, ECL_SYM("THE",856), VV[8], T1);
   return value0;
  }
 }
}
/*      function definition for INDEX-INCREMENT                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L5index_increment(cl_object v1type)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2name;
   cl_object v3increment;
   if (!(ECL_CONSP(v1type))) { goto L2; }
   v2name = ecl_car(v1type);
   goto L1;
L2:;
   v2name = v1type;
L1:;
   v3increment = ecl_get(v2name,VV[12],VV[13]);
   if (!((v3increment)==(VV[13]))) { goto L5; }
   T0 = cl_symbol_package(v2name);
   if ((T0)==(ecl_symbol_value(VV[14]))) { goto L7; }
   v2name = ecl_function_dispatch(cl_env_copy,VV[471])(1, v2name) /*  XINTERN */;
   v3increment = ecl_get(v2name,VV[12],VV[13]);
L7:;
   if (!((v3increment)==(VV[13]))) { goto L5; }
   cl_error(2, VV[15], v2name);
L5:;
   value0 = v3increment;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GETIFY                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L6getify(cl_object v1name)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[471])(2, v1name, VV[17]) /*  XINTERN */;
  return value0;
 }
}
/*      function definition for PUTIFY                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L7putify(cl_narg narg, cl_object v1name, ...)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2predicate_p;
  va_list args; va_start(args,v1name);
  {
   int i = 1;
   if (i >= narg) {
    v2predicate_p = ECL_NIL;
   } else {
    i++;
    v2predicate_p = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (Null(v2predicate_p)) { goto L3; }
  T0 = VV[20];
  goto L2;
L3:;
  T0 = VV[21];
L2:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[471])(3, v1name, VV[19], T0) /*  XINTERN */;
  return value0;
 }
}
/*      local function DEFINE-ACCESSOR                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC8define_accessor(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4name;
   cl_object v5;
   cl_object v6;
   cl_object v7width;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4name = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5 = v8;
   }
   v6 = v5;
   if (!(v6==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v8;
    v8 = ecl_car(v6);
    v6 = ecl_cdr(v6);
    v7width = v8;
   }
   if (Null(v6)) { goto L21; }
   si_dm_too_many_arguments(v1);
L21:;
   if (Null(ecl_cdddr(v3))) { goto L23; }
   T0 = ecl_cdddr(v3);
   cl_error(2, VV[23], T0);
L23:;
   {
    cl_object v8;
    cl_object v9;
    value0 = ecl_car(v3);
    if ((value0)!=ECL_NIL) { goto L27; }
    v8 = cl_error(2, VV[24], v4name);
    goto L25;
L27:;
    v8 = value0;
    goto L25;
L25:;
    value0 = ecl_cadr(v3);
    if ((value0)!=ECL_NIL) { goto L31; }
    v9 = cl_error(2, VV[25], v4name);
    goto L29;
L31:;
    v9 = value0;
    goto L29;
L29:;
    T0 = cl_list(2, v4name, VV[27]);
    T1 = cl_list(2, ECL_SYM("QUOTE",679), v4name);
    T2 = cl_list(3, ECL_SYM("GET",402), T1, VV[28]);
    if (Null(v7width)) { goto L35; }
    T3 = ecl_floor2(v7width,ecl_make_fixnum(8));
    goto L33;
L35:;
    T3 = ECL_NIL;
    goto L33;
L33:;
    T4 = cl_list(3, ECL_SYM("SETF",750), T2, T3);
    T5 = L6getify(v4name);
    T6 = ecl_car(v8);
    T7 = ecl_cdr(v8);
    T8 = cl_listX(4, ECL_SYM("DEFMACRO",283), T5, T6, T7);
    T9 = L7putify(1, v4name);
    T10 = ecl_car(v9);
    T11 = ecl_cdr(v9);
    T12 = cl_listX(4, ECL_SYM("DEFMACRO",283), T9, T10, T11);
    {
     cl_object v10predicating_put;
     v10predicating_put = ecl_caddr(v3);
     if (Null(v10predicating_put)) { goto L39; }
     T14 = cl_list(2, ECL_SYM("QUOTE",679), v4name);
     T15 = cl_list(3, ECL_SYM("GET",402), T14, VV[29]);
     T16 = cl_list(3, ECL_SYM("SETF",750), T15, ECL_T);
     T17 = L7putify(2, v4name, ECL_T);
     T18 = ecl_car(v10predicating_put);
     T19 = ecl_cdr(v10predicating_put);
     T20 = cl_listX(4, ECL_SYM("DEFMACRO",283), T17, T18, T19);
     T13 = cl_list(2, T16, T20);
     goto L37;
L39:;
     T13 = ECL_NIL;
    }
L37:;
    value0 = cl_listX(6, VV[26], T0, T4, T8, T12, T13);
    return value0;
   }
  }
 }
}
/*      local function CARD32-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC9card32_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[31], v4index);
   return value0;
  }
 }
}
/*      local function CARD32-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC10card32_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[33], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function CARD29-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC11card29_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[36], v4index);
   return value0;
  }
 }
}
/*      local function CARD29-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC12card29_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[38], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function CARD16-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC13card16_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[41], v4index);
   return value0;
  }
 }
}
/*      local function CARD16-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC14card16_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[43], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function CARD8-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC15card8_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[46], v4index);
   return value0;
  }
 }
}
/*      local function CARD8-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC16card8_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[48], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function INTEGER-GET                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC17integer_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[50], v4index);
   return value0;
  }
 }
}
/*      local function INTEGER-PUT                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC18integer_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[52], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function INT16-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC19int16_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[55], v4index);
   return value0;
  }
 }
}
/*      local function INT16-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC20int16_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[57], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function RGB-VAL-GET                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC21rgb_val_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, VV[41], v4index);
   value0 = cl_list(2, VV[60], T0);
   return value0;
  }
 }
}
/*      local function RGB-VAL-PUT                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC22rgb_val_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[62], v5thing);
   value0 = cl_list(3, VV[43], v4index, T0);
   return value0;
  }
 }
}
/*      local function ANGLE-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC23angle_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, VV[55], v4index);
   value0 = cl_list(2, VV[65], T0);
   return value0;
  }
 }
}
/*      local function ANGLE-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC24angle_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[67], v5thing);
   value0 = cl_list(3, VV[57], v4index, T0);
   return value0;
  }
 }
}
/*      local function BIT-GET                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC25bit_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5bit;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5bit = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[46], v4index);
   value0 = cl_list(3, ECL_SYM("LOGBITP",495), v5bit, T0);
   return value0;
  }
 }
}
/*      local function BIT-PUT                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC26bit_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6bit;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6bit = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   if (!(ecl_zerop(v6bit))) { goto L22; }
   T0 = cl_listX(3, ECL_SYM("IF",946), v5thing, VV[70]);
   value0 = cl_list(3, VV[48], v4index, T0);
   return value0;
L22:;
   T0 = cl_listX(3, ECL_SYM("IF",946), v5thing, VV[70]);
   T1 = cl_list(3, ECL_SYM("BYTE",162), ecl_make_fixnum(1), v6bit);
   T2 = cl_list(2, VV[46], v4index);
   T3 = cl_list(4, ECL_SYM("DPB",318), T0, T1, T2);
   value0 = cl_list(3, VV[48], v4index, T3);
   return value0;
  }
 }
}
/*      local function BOOLEAN-GET                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC27boolean_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, VV[46], v4index);
   value0 = cl_list(2, ECL_SYM("PLUSP",642), T0);
   return value0;
  }
 }
}
/*      local function BOOLEAN-PUT                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC28boolean_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_listX(3, ECL_SYM("IF",946), v5thing, VV[70]);
   value0 = cl_list(3, VV[48], v4index, T0);
   return value0;
  }
 }
}
/*      local function DRAWABLE-GET                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC29drawable_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[76], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function DRAWABLE-PUT                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC30drawable_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[78], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function WINDOW-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC31window_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[81], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function WINDOW-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC32window_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[83], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function PIXMAP-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC33pixmap_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[86], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function PIXMAP-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC34pixmap_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[88], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function GCONTEXT-GET                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC35gcontext_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[91], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function GCONTEXT-PUT                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC36gcontext_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[93], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function CURSOR-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC37cursor_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[96], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function CURSOR-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC38cursor_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[98], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function COLORMAP-GET                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC39colormap_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[101], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function COLORMAP-PUT                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC40colormap_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[103], v5thing);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function FONT-GET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC41font_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[106], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function FONT-PUT                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC42font_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_error(1, VV[108]);
   return value0;
  }
 }
}
/*      local function KEYWORD-GET                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC43keyword_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5buffer = v6;
    goto L8;
   }
L9:;
   v5buffer = VV[75];
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, VV[36], v4index);
   value0 = cl_list(3, VV[110], v5buffer, T0);
   return value0;
  }
 }
}
/*      local function KEYWORD-PUT                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC44keyword_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6;
   cl_object v7buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v8;
   }
   v6 = si_search_keyword(2, v3, VV[112]);
   if (!((v6)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L16; }
   v7buffer = VV[75];
   goto L15;
L16:;
   v7buffer = v6;
L15:;
   si_check_keyword(2, v3, VV[113]);
   T0 = cl_list(3, VV[114], v5thing, v7buffer);
   T1 = cl_list(3, ECL_SYM("OR",614), T0, VV[115]);
   value0 = cl_list(3, VV[38], v4index, T1);
   return value0;
  }
 }
}
/*      local function RESOURCE-ID-GET                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC45resource_id_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = cl_list(2, VV[36], v4index);
   return value0;
  }
 }
}
/*      local function RESOURCE-ID-PUT                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC46resource_id_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[38], v4index, v5thing);
   return value0;
  }
 }
}
/*      local function RESOURCE-ID-OR-NIL-GET                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC47resource_id_or_nil_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   {
    cl_object v5id;
    v5id = cl_gensym(0);
    T0 = cl_list(2, VV[36], v4index);
    T1 = cl_list(2, v5id, T0);
    T2 = ecl_list1(T1);
    T3 = cl_list(2, ECL_SYM("PLUSP",642), v5id);
    T4 = cl_list(3, ECL_SYM("AND",87), T3, v5id);
    value0 = cl_list(3, ECL_SYM("LET",477), T2, T4);
    return value0;
   }
  }
 }
}
/*      local function RESOURCE-ID-OR-NIL-PUT                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC48resource_id_or_nil_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(3, ECL_SYM("OR",614), v5thing, ecl_make_fixnum(0));
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function CHAR-INFO-GET                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC49char_info_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, VV[56], v4index);
   T1 = ecl_plus(v4index,ecl_make_fixnum(2));
   T2 = cl_list(2, VV[56], T1);
   T3 = ecl_plus(v4index,ecl_make_fixnum(4));
   T4 = cl_list(2, VV[56], T3);
   T5 = ecl_plus(v4index,ecl_make_fixnum(6));
   T6 = cl_list(2, VV[56], T5);
   T7 = ecl_plus(v4index,ecl_make_fixnum(8));
   T8 = cl_list(2, VV[56], T7);
   T9 = ecl_plus(v4index,ecl_make_fixnum(10));
   T10 = cl_list(2, VV[42], T9);
   value0 = cl_list(13, VV[123], VV[124], T0, VV[125], T2, VV[126], T4, VV[127], T6, VV[128], T8, VV[129], T10);
   return value0;
  }
 }
}
/*      local function MEMBER8-GET                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC50member8_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   {
    cl_object v5value;
    v5value = cl_gensym(0);
    T0 = cl_list(2, VV[46], v4index);
    T1 = cl_list(2, v5value, T0);
    T2 = ecl_list1(T1);
    {
     cl_fixnum v6;
     v6 = ecl_length(v3);
     T3 = ecl_list1(ecl_make_fixnum(v6));
     T4 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T3);
     T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v5value);
     T6 = cl_list(2, ECL_SYM("DECLARE",274), T5);
     {
      cl_fixnum v7;
      v7 = ecl_length(v3);
      T7 = ecl_list1(ecl_make_fixnum(v7));
      T8 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T7);
      T9 = cl_list(2, ECL_SYM("QUOTE",679), T8);
      T10 = cl_list(3, VV[2], v5value, T9);
      T11 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
      T12 = cl_apply(2, T11, v3);
      T13 = cl_list(2, ECL_SYM("QUOTE",679), T12);
      T14 = cl_list(3, ECL_SYM("SVREF",838), T13, v5value);
      value0 = cl_list(5, ECL_SYM("LET",477), T2, T6, T10, T14);
      return value0;
     }
    }
   }
  }
 }
}
/*      local function MEMBER8-PUT                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC51member8_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
   T1 = cl_apply(2, T0, v3);
   T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
   T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
   T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
   value0 = cl_list(3, VV[48], v4index, T4);
   return value0;
  }
 }
}
/*      local function MEMBER8-PUT-PREDICATING                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC52member8_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   {
    cl_object v6value;
    v6value = cl_gensym(0);
    T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
    T1 = cl_apply(2, T0, v3);
    T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
    T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
    T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
    T5 = cl_list(2, v6value, T4);
    T6 = ecl_list1(T5);
    T7 = cl_list(3, VV[48], v4index, v6value);
    T8 = cl_list(3, ECL_SYM("AND",87), v6value, T7);
    value0 = cl_list(3, ECL_SYM("LET",477), T6, T8);
    return value0;
   }
  }
 }
}
/*      local function MEMBER16-GET                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC53member16_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   {
    cl_object v5value;
    v5value = cl_gensym(0);
    T0 = cl_list(2, VV[41], v4index);
    T1 = cl_list(2, v5value, T0);
    T2 = ecl_list1(T1);
    {
     cl_fixnum v6;
     v6 = ecl_length(v3);
     T3 = ecl_list1(ecl_make_fixnum(v6));
     T4 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T3);
     T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v5value);
     T6 = cl_list(2, ECL_SYM("DECLARE",274), T5);
     {
      cl_fixnum v7;
      v7 = ecl_length(v3);
      T7 = ecl_list1(ecl_make_fixnum(v7));
      T8 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T7);
      T9 = cl_list(2, ECL_SYM("QUOTE",679), T8);
      T10 = cl_list(3, VV[2], v5value, T9);
      T11 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
      T12 = cl_apply(2, T11, v3);
      T13 = cl_list(2, ECL_SYM("QUOTE",679), T12);
      T14 = cl_list(3, ECL_SYM("SVREF",838), T13, v5value);
      value0 = cl_list(5, ECL_SYM("LET",477), T2, T6, T10, T14);
      return value0;
     }
    }
   }
  }
 }
}
/*      local function MEMBER16-PUT                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC54member16_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
   T1 = cl_apply(2, T0, v3);
   T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
   T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
   T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
   value0 = cl_list(3, VV[43], v4index, T4);
   return value0;
  }
 }
}
/*      local function MEMBER16-PUT-PREDICATING                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC55member16_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   {
    cl_object v6value;
    v6value = cl_gensym(0);
    T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
    T1 = cl_apply(2, T0, v3);
    T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
    T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
    T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
    T5 = cl_list(2, v6value, T4);
    T6 = ecl_list1(T5);
    T7 = cl_list(3, VV[43], v4index, v6value);
    T8 = cl_list(3, ECL_SYM("AND",87), v6value, T7);
    value0 = cl_list(3, ECL_SYM("LET",477), T6, T8);
    return value0;
   }
  }
 }
}
/*      local function MEMBER-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC56member_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   {
    cl_object v5value;
    v5value = cl_gensym(0);
    T0 = cl_list(2, VV[36], v4index);
    T1 = cl_list(2, v5value, T0);
    T2 = ecl_list1(T1);
    {
     cl_fixnum v6;
     v6 = ecl_length(v3);
     T3 = ecl_list1(ecl_make_fixnum(v6));
     T4 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T3);
     T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v5value);
     T6 = cl_list(2, ECL_SYM("DECLARE",274), T5);
     {
      cl_fixnum v7;
      v7 = ecl_length(v3);
      T7 = ecl_list1(ecl_make_fixnum(v7));
      T8 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T7);
      T9 = cl_list(2, ECL_SYM("QUOTE",679), T8);
      T10 = cl_list(3, VV[2], v5value, T9);
      T11 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
      T12 = cl_apply(2, T11, v3);
      T13 = cl_list(2, ECL_SYM("QUOTE",679), T12);
      T14 = cl_list(3, ECL_SYM("SVREF",838), T13, v5value);
      value0 = cl_list(5, ECL_SYM("LET",477), T2, T6, T10, T14);
      return value0;
     }
    }
   }
  }
 }
}
/*      local function MEMBER-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC57member_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
   T1 = cl_apply(2, T0, v3);
   T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
   T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
   T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
   value0 = cl_list(3, VV[38], v4index, T4);
   return value0;
  }
 }
}
/*      local function MEMBER-PUT-PREDICATING                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC58member_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(ecl_cdr(v3))) { goto L14; }
   {
    cl_object v6value;
    v6value = cl_gensym(0);
    T0 = (ECL_SYM("VECTOR",898)->symbol.gfdef);
    T1 = cl_apply(2, T0, v3);
    T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
    T3 = cl_list(3, ECL_SYM("THE",856), ECL_SYM("SIMPLE-VECTOR",774), T2);
    T4 = cl_listX(4, ECL_SYM("POSITION",644), v5thing, T3, VV[133]);
    T5 = cl_list(2, v6value, T4);
    T6 = ecl_list1(T5);
    T7 = cl_list(3, VV[38], v4index, v6value);
    T8 = cl_list(3, ECL_SYM("AND",87), v6value, T7);
    value0 = cl_list(3, ECL_SYM("LET",477), T6, T8);
    return value0;
   }
L14:;
   T0 = ecl_car(v3);
   T1 = cl_list(3, ECL_SYM("EQ",333), v5thing, T0);
   T2 = cl_list(3, VV[38], v4index, ecl_make_fixnum(0));
   value0 = cl_list(3, ECL_SYM("AND",87), T1, T2);
   return value0;
  }
 }
}
/*      local function MEMBER-VECTOR                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC59member_vector(cl_object v1)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   cl_object v3vector;
   v2 = v1;
   if (!(v2==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v4;
    v4 = ecl_car(v2);
    v2 = ecl_cdr(v2);
    v3vector = v4;
   }
   if (Null(v2)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_symbol_value(v3vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = CONS(ECL_SYM("MEMBER",552),T1);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function MEMBER-VECTOR-GET                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC60member_vector_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5membership_vector = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_eval(v5membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(3, VV[141], v4index, T1);
   return value0;
  }
 }
}
/*      local function MEMBER-VECTOR-PUT                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC61member_vector_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[142], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function MEMBER-VECTOR-PUT-PREDICATING                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC62member_vector_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[142], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function MEMBER16-VECTOR-GET                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC63member16_vector_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5membership_vector = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_eval(v5membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(3, VV[138], v4index, T1);
   return value0;
  }
 }
}
/*      local function MEMBER16-VECTOR-PUT                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC64member16_vector_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[139], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function MEMBER16-VECTOR-PUT-PREDICATING                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC65member16_vector_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[139], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function MEMBER8-VECTOR-GET                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC66member8_vector_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5membership_vector = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_eval(v5membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(3, VV[132], v4index, T1);
   return value0;
  }
 }
}
/*      local function MEMBER8-VECTOR-PUT                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC67member8_vector_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[134], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function MEMBER8-VECTOR-PUT-PREDICATING                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC68member8_vector_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6membership_vector;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6membership_vector = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_eval(v6membership_vector);
   T1 = si_coerce_to_list(1, T0);
   value0 = cl_listX(4, VV[134], v4index, v5thing, T1);
   return value0;
  }
 }
}
/*      local function BOOLE-CONSTANT-GET                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC69boole_constant_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   {
    cl_object v5value;
    v5value = cl_gensym(0);
    T0 = cl_list(2, VV[36], v4index);
    T1 = cl_list(2, v5value, T0);
    T2 = ecl_list1(T1);
    {
     cl_fixnum v6;
     v6 = ecl_length(ecl_symbol_value(VV[157]));
     T3 = ecl_list1(ecl_make_fixnum(v6));
     T4 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T3);
     T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v5value);
     T6 = cl_list(2, ECL_SYM("DECLARE",274), T5);
     {
      cl_fixnum v7;
      v7 = ecl_length(ecl_symbol_value(VV[157]));
      T7 = ecl_list1(ecl_make_fixnum(v7));
      T8 = cl_list(3, ECL_SYM("INTEGER",437), ecl_make_fixnum(0), T7);
      T9 = cl_list(2, ECL_SYM("QUOTE",679), T8);
      T10 = cl_list(3, VV[2], v5value, T9);
      T11 = cl_list(3, ECL_SYM("SVREF",838), VV[157], v5value);
      value0 = cl_list(5, ECL_SYM("LET",477), T2, T6, T10, T11);
      return value0;
     }
    }
   }
  }
 }
}
/*      local function BOOLE-CONSTANT-PUT                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC70boole_constant_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(3, ECL_SYM("POSITION",644), v5thing, VV[159]);
   value0 = cl_list(3, VV[38], v4index, T0);
   return value0;
  }
 }
}
/*      local function BOOLE-CONSTANT-PUT-PREDICATING                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC71boole_constant_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   {
    cl_object v6value;
    v6value = cl_gensym(0);
    T0 = cl_list(3, ECL_SYM("POSITION",644), v5thing, VV[159]);
    T1 = cl_list(2, v6value, T0);
    T2 = ecl_list1(T1);
    T3 = cl_list(3, VV[38], v4index, v6value);
    T4 = cl_list(3, ECL_SYM("AND",87), v6value, T3);
    value0 = cl_list(3, ECL_SYM("LET",477), T2, T4);
    return value0;
   }
  }
 }
}
/*      local function NULL-GET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC72null_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = cl_list(2, VV[31], v4index);
   T1 = cl_list(2, ECL_SYM("ZEROP",926), T0);
   T2 = cl_list(2, VV[31], v4index);
   value0 = cl_list(4, ECL_SYM("IF",946), T1, ECL_NIL, T2);
   return value0;
  }
 }
}
/*      local function NULL-PUT                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC73null_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[33], v4index, ecl_make_fixnum(0));
   return value0;
  }
 }
}
/*      local function PAD8-GET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC74pad8_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PAD8-PUT                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC75pad8_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PAD16-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC76pad16_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PAD16-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC77pad16_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PAD32-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC78pad32_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PAD32-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC79pad32_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function BIT-VECTOR256-GET                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC80bit_vector256_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5real_index;
   cl_object v6data;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5real_index = v7;
    goto L8;
   }
L9:;
   v5real_index = v4index;
L8:;
   if (Null(v3)) { goto L15; }
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6data = v7;
    goto L14;
   }
L15:;
   v6data = ECL_NIL;
L14:;
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   value0 = cl_list(4, VV[174], VV[175], v5real_index, v6data);
   return value0;
  }
 }
}
/*      local function BIT-VECTOR256-PUT                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC81bit_vector256_put(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5map;
   cl_object v6real_index;
   cl_object v7buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5map = v8;
   }
   if (Null(v3)) { goto L15; }
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6real_index = v8;
    goto L14;
   }
L15:;
   v6real_index = v4index;
L14:;
   if (Null(v3)) { goto L21; }
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7buffer = v8;
    goto L20;
   }
L21:;
   v7buffer = VV[75];
L20:;
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   T0 = cl_list(3, VV[9], VV[178], v6real_index);
   value0 = cl_list(4, VV[177], v7buffer, T0, v5map);
   return value0;
  }
 }
}
/*      local function STRING-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC82string_get(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4length;
   cl_object v5index;
   cl_object v6;
   cl_object v7reply_buffer;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4length = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5index = v8;
   }
   v6 = si_search_keyword(2, v3, VV[180]);
   if (!((v6)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L16; }
   v7reply_buffer = ECL_NIL;
   goto L15;
L16:;
   v7reply_buffer = v6;
L15:;
   si_check_keyword(2, v3, VV[181]);
   value0 = v7reply_buffer;
   if ((value0)!=ECL_NIL) { goto L21; }
   T0 = VV[183];
   goto L19;
L21:;
   T0 = value0;
   goto L19;
L19:;
   value0 = cl_list(8, VV[182], T0, VV[184], v4length, ECL_NIL, ECL_NIL, ecl_make_fixnum(0), v5index);
   return value0;
  }
 }
}
/*      local function STRING-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC83string_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5string;
   cl_object v6;
   cl_object v7buffer;
   cl_object v8;
   cl_object v9start;
   cl_object v10;
   cl_object v11end;
   cl_object v12;
   cl_object v13header_length;
   cl_object v14;
   cl_object v15appending;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v16;
    v16 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v16;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v16;
    v16 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5string = v16;
   }
   v6 = si_search_keyword(2, v3, VV[112]);
   if (!((v6)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L16; }
   v7buffer = ECL_NIL;
   goto L15;
L16:;
   v7buffer = v6;
L15:;
   v8 = si_search_keyword(2, v3, ECL_SYM("START",1313));
   if (!((v8)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L20; }
   v9start = ecl_make_fixnum(0);
   goto L19;
L20:;
   v9start = v8;
L19:;
   v10 = si_search_keyword(2, v3, ECL_SYM("END",1228));
   if (!((v10)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L24; }
   v11end = ECL_NIL;
   goto L23;
L24:;
   v11end = v10;
L23:;
   v12 = si_search_keyword(2, v3, VV[186]);
   if (!((v12)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L28; }
   v13header_length = ECL_NIL;
   goto L27;
L28:;
   v13header_length = v12;
L27:;
   v14 = si_search_keyword(2, v3, VV[187]);
   if (!((v14)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L32; }
   v15appending = ECL_NIL;
   goto L31;
L32:;
   v15appending = v14;
L31:;
   si_check_keyword(2, v3, VV[188]);
   if ((v7buffer)!=ECL_NIL) { goto L35; }
   v7buffer = VV[75];
L35:;
   if ((v13header_length)!=ECL_NIL) { goto L38; }
   {
    cl_fixnum v16;
    {
     cl_fixnum v17;
     {
      cl_object v18;
      {
       cl_fixnum v19;
       {
        cl_object v20;
        v20 = v4index;
        {
         cl_fixnum v21;
         v21 = 0;
         if (!(ECL_FIXNUMP(v20))) { goto L50; }
         v21 = ecl_fixnum(v20);
         if (!((v21)<=(536870911))) { goto L55; }
         T0 = ecl_make_bool((v21)>=(0));
         goto L47;
L55:;
         T0 = ECL_NIL;
         goto L47;
L50:;
         T0 = ECL_NIL;
         goto L47;
        }
L47:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v20);
        v19 = ecl_fixnum(v20);
       }
       v18 = ecl_plus(ecl_make_fixnum(v19),ecl_make_fixnum(3));
      }
      {
       cl_fixnum v19;
       v19 = 0;
       if (!(ECL_FIXNUMP(v18))) { goto L61; }
       v19 = ecl_fixnum(v18);
       if (!((v19)<=(536870911))) { goto L66; }
       T0 = ecl_make_bool((v19)>=(0));
       goto L58;
L66:;
       T0 = ECL_NIL;
       goto L58;
L61:;
       T0 = ECL_NIL;
       goto L58;
      }
L58:;
      if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v18);
      v17 = ecl_fixnum(v18);
     }
     v16 = ((v17) & (-4));
    }
    {
     cl_fixnum v17;
     v17 = 0;
     v17 = v16;
     if (!((v17)<=(536870911))) { goto L77; }
     T0 = ecl_make_bool((v17)>=(0));
     goto L69;
L77:;
     T0 = ECL_NIL;
     goto L69;
     T0 = ECL_NIL;
     goto L69;
    }
L69:;
    if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],ecl_make_fixnum(v16));
    v13header_length = ecl_make_fixnum(v16);
   }
L38:;
   {
    cl_object v16real_end;
    cl_object v17form;
    if (Null(v15appending)) { goto L80; }
    value0 = v11end;
    if ((value0)!=ECL_NIL) { goto L83; }
    v16real_end = cl_list(2, ECL_SYM("LENGTH",476), v5string);
    goto L79;
L83:;
    v16real_end = value0;
    goto L79;
L80:;
    v16real_end = cl_gensym(0);
L79:;
    T0 = cl_list(3, VV[9], VV[178], v13header_length);
    v17form = cl_list(6, VV[189], v7buffer, T0, v5string, v9start, v16real_end);
    if (Null(v15appending)) { goto L86; }
    value0 = v17form;
    cl_env_copy->nvalues = 1;
    return value0;
L86:;
    value0 = v11end;
    if ((value0)!=ECL_NIL) { goto L90; }
    T0 = cl_list(2, ECL_SYM("LENGTH",476), v5string);
    goto L88;
L90:;
    T0 = value0;
    goto L88;
L88:;
    T1 = cl_list(2, v16real_end, T0);
    T2 = ecl_list1(T1);
    T3 = cl_list(3, VV[191], v16real_end, v9start);
    T4 = cl_list(3, VV[9], T3, v13header_length);
    T5 = cl_list(3, VV[190], T4, ecl_make_fixnum(4));
    T6 = cl_list(3, VV[43], ecl_make_fixnum(2), T5);
    value0 = cl_list(4, ECL_SYM("LET",477), T2, T6, v17form);
    return value0;
   }
  }
 }
}
/*      local function SEQUENCE-GET                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC84sequence_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5length;
   cl_object v6;
   cl_object v7format;
   cl_object v8;
   cl_object v9result_type;
   cl_object v10;
   cl_object v11transform;
   cl_object v12;
   cl_object v13reply_buffer;
   cl_object v14;
   cl_object v15data;
   cl_object v16;
   cl_object v17index;
   cl_object v18;
   cl_object v19start;
   v3 = ecl_cdr(v1);
   v4 = si_search_keyword(2, v3, ECL_SYM("LENGTH",1266));
   if (!((v4)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L4; }
   v5length = ECL_NIL;
   goto L3;
L4:;
   v5length = v4;
L3:;
   v6 = si_search_keyword(2, v3, VV[193]);
   if (!((v6)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L8; }
   v7format = VV[30];
   goto L7;
L8:;
   v7format = v6;
L7:;
   v8 = si_search_keyword(2, v3, VV[194]);
   if (!((v8)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L12; }
   v9result_type = ECL_NIL;
   goto L11;
L12:;
   v9result_type = v8;
L11:;
   v10 = si_search_keyword(2, v3, VV[195]);
   if (!((v10)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L16; }
   v11transform = ECL_NIL;
   goto L15;
L16:;
   v11transform = v10;
L15:;
   v12 = si_search_keyword(2, v3, VV[180]);
   if (!((v12)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L20; }
   v13reply_buffer = ECL_NIL;
   goto L19;
L20:;
   v13reply_buffer = v12;
L19:;
   v14 = si_search_keyword(2, v3, VV[196]);
   if (!((v14)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L24; }
   v15data = ECL_NIL;
   goto L23;
L24:;
   v15data = v14;
L23:;
   v16 = si_search_keyword(2, v3, VV[197]);
   if (!((v16)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L28; }
   v17index = ECL_NIL;
   goto L27;
L28:;
   v17index = v16;
L27:;
   v18 = si_search_keyword(2, v3, ECL_SYM("START",1313));
   if (!((v18)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L32; }
   v19start = ECL_NIL;
   goto L31;
L32:;
   v19start = v18;
L31:;
   si_check_keyword(2, v3, VV[198]);
   if (!((v7format)==(VV[45]))) { goto L36; }
   T0 = VV[199];
   goto L35;
L36:;
   if (!((v7format)==(VV[200]))) { goto L38; }
   T0 = VV[201];
   goto L35;
L38:;
   if (!((v7format)==(VV[40]))) { goto L40; }
   T0 = VV[202];
   goto L35;
L40:;
   if (!((v7format)==(VV[54]))) { goto L42; }
   T0 = VV[203];
   goto L35;
L42:;
   if (!((v7format)==(VV[30]))) { goto L44; }
   T0 = VV[204];
   goto L35;
L44:;
   if (!((v7format)==(VV[205]))) { goto L46; }
   T0 = VV[206];
   goto L35;
L46:;
   T0 = si_ecase_error(v7format, VV[207]);
L35:;
   value0 = v13reply_buffer;
   if ((value0)!=ECL_NIL) { goto L50; }
   T1 = VV[183];
   goto L48;
L50:;
   T1 = value0;
   goto L48;
L48:;
   if ((v19start)!=ECL_NIL) { goto L55; }
   if (Null(v17index)) { goto L53; }
   goto L54;
L55:;
L54:;
   value0 = v19start;
   if ((value0)!=ECL_NIL) { goto L59; }
   T3 = ecl_make_fixnum(0);
   goto L57;
L59:;
   T3 = value0;
   goto L57;
L57:;
   T2 = ecl_list1(T3);
   goto L52;
L53:;
   T2 = ECL_NIL;
L52:;
   if (Null(v17index)) { goto L62; }
   T3 = ecl_list1(v17index);
   goto L61;
L62:;
   T3 = ECL_NIL;
L61:;
   T4 = ecl_append(T2,T3);
   value0 = cl_listX(7, T0, T1, v9result_type, v5length, v11transform, v15data, T4);
   return value0;
  }
 }
}
/*      local function SEQUENCE-PUT                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC86sequence_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 volatile cl_object lex0[7];
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5format;
   cl_object v6;
   cl_object v7;
   cl_object v8;
   cl_object v9transform;
   cl_object v10;
   cl_object v11buffer;
   cl_object v12;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L2; }
   si_dm_too_few_arguments(v1);
L2:;
   {
    cl_object v13;
    v13 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    T0 = v13;
   }
   lex0[0] = T0;                                  /*  INDEX           */
   if (!(v3==ECL_NIL)) { goto L8; }
   si_dm_too_few_arguments(v1);
L8:;
   {
    cl_object v13;
    v13 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    T0 = v13;
   }
   lex0[1] = T0;                                  /*  DATA            */
   v4 = si_search_keyword(2, v3, VV[193]);
   if (!((v4)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L16; }
   v5format = VV[30];
   goto L15;
L16:;
   v5format = v4;
L15:;
   v6 = si_search_keyword(2, v3, ECL_SYM("START",1313));
   if (!((v6)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L20; }
   T0 = ecl_make_fixnum(0);
   goto L19;
L20:;
   T0 = v6;
L19:;
   lex0[2] = T0;                                  /*  START           */
   v7 = si_search_keyword(2, v3, ECL_SYM("END",1228));
   if (!((v7)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L24; }
   T0 = ECL_NIL;
   goto L23;
L24:;
   T0 = v7;
L23:;
   lex0[3] = T0;                                  /*  END             */
   v8 = si_search_keyword(2, v3, VV[195]);
   if (!((v8)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L28; }
   v9transform = ECL_NIL;
   goto L27;
L28:;
   v9transform = v8;
L27:;
   v10 = si_search_keyword(2, v3, VV[112]);
   if (!((v10)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L32; }
   v11buffer = ECL_NIL;
   goto L31;
L32:;
   v11buffer = v10;
L31:;
   v12 = si_search_keyword(2, v3, VV[187]);
   if (!((v12)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L36; }
   T0 = ECL_NIL;
   goto L35;
L36:;
   T0 = v12;
L35:;
   lex0[4] = T0;                                  /*  APPENDING       */
   si_check_keyword(2, v3, VV[209]);
   if ((v11buffer)!=ECL_NIL) { goto L39; }
   v11buffer = VV[75];
L39:;
   {
    cl_object v13writer;
    if (Null(lex0[4])) { goto L43; }
    value0 = lex0[3];
    if ((value0)!=ECL_NIL) { goto L46; }
    T0 = cl_list(2, ECL_SYM("LENGTH",476), lex0[1]);
    goto L42;
L46:;
    T0 = value0;
    goto L42;
L43:;
    T0 = cl_gensym(0);
L42:;
    lex0[5] = T0;                                 /*  REAL-END        */
    v13writer = ecl_function_dispatch(cl_env_copy,VV[471])(2, VV[210], v5format) /*  XINTERN */;
    {
     cl_fixnum v14;
     {
      cl_fixnum v15;
      {
       cl_fixnum v16;
       {
        cl_object v17;
        {
         cl_fixnum v18;
         {
          cl_object v19;
          v19 = lex0[0];
          {
          cl_fixnum v20;
          v20 = 0;
          if (!(ECL_FIXNUMP(v19))) { goto L59; }
          v20 = ecl_fixnum(v19);
          if (!((v20)<=(536870911))) { goto L64; }
          T0 = ecl_make_bool((v20)>=(0));
          goto L56;
L64:;
          T0 = ECL_NIL;
          goto L56;
L59:;
          T0 = ECL_NIL;
          goto L56;
          }
L56:;
          if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v19);
          v18 = ecl_fixnum(v19);
         }
         v17 = ecl_plus(ecl_make_fixnum(v18),ecl_make_fixnum(3));
        }
        {
         cl_fixnum v18;
         v18 = 0;
         if (!(ECL_FIXNUMP(v17))) { goto L70; }
         v18 = ecl_fixnum(v17);
         if (!((v18)<=(536870911))) { goto L75; }
         T0 = ecl_make_bool((v18)>=(0));
         goto L67;
L75:;
         T0 = ECL_NIL;
         goto L67;
L70:;
         T0 = ECL_NIL;
         goto L67;
        }
L67:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v17);
        v16 = ecl_fixnum(v17);
       }
       v15 = ((v16) & (-4));
      }
      {
       cl_fixnum v16;
       v16 = 0;
       v16 = v15;
       if (!((v16)<=(536870911))) { goto L86; }
       T0 = ecl_make_bool((v16)>=(0));
       goto L78;
L86:;
       T0 = ECL_NIL;
       goto L78;
       T0 = ECL_NIL;
       goto L78;
      }
L78:;
      if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],ecl_make_fixnum(v15));
      v14 = v15;
     }
     T0 = cl_list(3, VV[9], VV[178], ecl_make_fixnum(v14));
     T1 = cl_list(7, v13writer, v11buffer, T0, lex0[1], lex0[2], lex0[5], v9transform);
     lex0[6] = T1;                                /*  FORM            */
    }
    if (!((v5format)==(VV[45]))) { goto L93; }
    goto L90;
    goto L91;
L93:;
    goto L91;
L91:;
    if (!((v5format)==(VV[200]))) { goto L88; }
    goto L89;
L90:;
L89:;
    value0 = LC85maker(lex0, ecl_make_fixnum(4));
    return value0;
L88:;
    if (!((v5format)==(VV[40]))) { goto L101; }
    goto L98;
    goto L99;
L101:;
    goto L99;
L99:;
    if (!((v5format)==(VV[54]))) { goto L105; }
    goto L98;
    goto L103;
L105:;
    goto L103;
L103:;
    if (!((v5format)==(VV[215]))) { goto L96; }
    goto L97;
L98:;
L97:;
    value0 = LC85maker(lex0, ecl_make_fixnum(2));
    return value0;
L96:;
    if (!((v5format)==(VV[30]))) { goto L113; }
    goto L110;
    goto L111;
L113:;
    goto L111;
L111:;
    if (!((v5format)==(VV[205]))) { goto L108; }
    goto L109;
L110:;
L109:;
    value0 = LC85maker(lex0, ecl_make_fixnum(1));
    return value0;
L108:;
    value0 = si_ecase_error(v5format, VV[219]);
    return value0;
   }
  }
 }
}
/*      local function MAKER                                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC85maker(volatile cl_object *lex0, cl_object v1size)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(lex0[4])) { goto L1; }
  value0 = lex0[6];
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  {
   cl_object v2idx;
   v2idx = cl_list(3, VV[191], lex0[5], lex0[2]);
   if (ecl_number_equalp(v1size,ecl_make_fixnum(1))) { goto L4; }
   v2idx = cl_list(3, VV[190], v2idx, v1size);
L4:;
   value0 = lex0[3];
   if ((value0)!=ECL_NIL) { goto L9; }
   T0 = cl_list(2, ECL_SYM("LENGTH",476), lex0[1]);
   goto L7;
L9:;
   T0 = value0;
   goto L7;
L7:;
   T1 = cl_list(2, lex0[5], T0);
   T2 = ecl_list1(T1);
   {
    cl_fixnum v3;
    {
     cl_object v4;
     {
      cl_fixnum v5;
      {
       cl_object v6;
       v6 = lex0[0];
       {
        cl_fixnum v7;
        v7 = 0;
        if (!(ECL_FIXNUMP(v6))) { goto L19; }
        v7 = ecl_fixnum(v6);
        if (!((v7)<=(536870911))) { goto L24; }
        T3 = ecl_make_bool((v7)>=(0));
        goto L16;
L24:;
        T3 = ECL_NIL;
        goto L16;
L19:;
        T3 = ECL_NIL;
        goto L16;
       }
L16:;
       if (ecl_unlikely(!((T3)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v6);
       v5 = ecl_fixnum(v6);
      }
      v4 = ecl_ceiling2(ecl_make_fixnum(v5),ecl_make_fixnum(4));
     }
     {
      cl_fixnum v5;
      v5 = 0;
      if (!(ECL_FIXNUMP(v4))) { goto L30; }
      v5 = ecl_fixnum(v4);
      if (!((v5)<=(536870911))) { goto L35; }
      T3 = ecl_make_bool((v5)>=(0));
      goto L27;
L35:;
      T3 = ECL_NIL;
      goto L27;
L30:;
      T3 = ECL_NIL;
      goto L27;
     }
L27:;
     if (ecl_unlikely(!((T3)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v4);
     v3 = ecl_fixnum(v4);
    }
    T3 = cl_list(3, VV[9], v2idx, ecl_make_fixnum(v3));
    T4 = cl_list(3, VV[43], ecl_make_fixnum(2), T3);
    value0 = cl_list(4, ECL_SYM("LET",477), T2, T4, lex0[6]);
    return value0;
   }
  }
 }
}
/*      local function CLIENT-MESSAGE-EVENT-GET-SEQUENCE              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC87client_message_event_get_sequence(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   v3 = ecl_cdr(v1);
   if (Null(v3)) { goto L2; }
   si_dm_too_many_arguments(v1);
L2:;
   value0 = VV[221];
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function CLIENT-MESSAGE-EVENT-PUT-SEQUENCE              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC88client_message_event_put_sequence(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4format;
   cl_object v5sequence;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4format = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5sequence = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, ECL_SYM("LENGTH",476), v5sequence);
   T1 = cl_list(3, ECL_SYM("MIN",557), T0, ecl_make_fixnum(20));
   T2 = cl_listX(8, VV[220], ecl_make_fixnum(12), v5sequence, VV[193], VV[45], ECL_SYM("END",1228), T1, VV[223]);
   T3 = cl_list(2, ecl_make_fixnum(8), T2);
   T4 = cl_list(2, ECL_SYM("LENGTH",476), v5sequence);
   T5 = cl_list(3, ECL_SYM("MIN",557), T4, ecl_make_fixnum(10));
   T6 = cl_listX(8, VV[220], ecl_make_fixnum(12), v5sequence, VV[193], VV[40], ECL_SYM("END",1228), T5, VV[223]);
   T7 = cl_list(2, ecl_make_fixnum(16), T6);
   T8 = cl_list(2, ECL_SYM("LENGTH",476), v5sequence);
   T9 = cl_list(3, ECL_SYM("MIN",557), T8, ecl_make_fixnum(5));
   T10 = cl_listX(8, VV[220], ecl_make_fixnum(12), v5sequence, VV[193], VV[30], ECL_SYM("END",1228), T9, VV[223]);
   T11 = cl_list(2, ecl_make_fixnum(32), T10);
   value0 = cl_list(5, ECL_SYM("ECASE",321), v4format, T3, T7, T11);
   return value0;
  }
 }
}
/*      local function CLIENT-MESSAGE-SEQUENCE-GET                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC89client_message_sequence_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5format;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5format = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = VV[226];
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function CLIENT-MESSAGE-SEQUENCE-PUT                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC90client_message_sequence_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   cl_object v6format;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6format = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   value0 = cl_list(3, VV[224], v6format, v5value);
   return value0;
  }
 }
}
/*      local function CODE-GET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC91code_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = VV[230];
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function CODE-PUT                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC92code_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[48], ecl_make_fixnum(0), v5value);
   return value0;
  }
 }
}
/*      local function CODE-PUT-PREDICATING                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC93code_put_predicating(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[48], ecl_make_fixnum(0), v5value);
   return value0;
  }
 }
}
/*      local function LENGTH-GET                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC94length_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   value0 = VV[234];
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function LENGTH-PUT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC95length_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[43], ecl_make_fixnum(2), v5value);
   return value0;
  }
 }
}
/*      local function LENGTH-PUT-PREDICATING                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC96length_put_predicating(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = cl_list(3, VV[43], ecl_make_fixnum(2), v5value);
   return value0;
  }
 }
}
/*      local function DATA-GET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC97data_get(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5stuff;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (Null(v3)) { goto L9; }
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5stuff = v6;
    goto L8;
   }
L9:;
   v5stuff = ECL_NIL;
L8:;
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   if (Null(v5stuff)) { goto L16; }
   if (!(ECL_CONSP(v5stuff))) { goto L18; }
   T0 = ecl_car(v5stuff);
   T1 = L6getify(T0);
   T2 = ecl_cdr(v5stuff);
   value0 = cl_listX(3, T1, ecl_make_fixnum(1), T2);
   return value0;
L18:;
   T0 = L6getify(v5stuff);
   value0 = cl_list(2, T0, ecl_make_fixnum(1));
   return value0;
L16:;
   value0 = VV[239];
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function DATA-PUT                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC98data_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6stuff;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (Null(v3)) { goto L15; }
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6stuff = v7;
    goto L14;
   }
L15:;
   v6stuff = ECL_NIL;
L14:;
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   if (Null(v6stuff)) { goto L22; }
   if (!(ECL_CONSP(v6stuff))) { goto L24; }
   T0 = ecl_car(v6stuff);
   T1 = L7putify(1, T0);
   T2 = ecl_cdr(v6stuff);
   T3 = cl_listX(4, T1, v4index, v5thing, T2);
   T4 = cl_list(3, VV[48], ecl_make_fixnum(1), T3);
   value0 = cl_list(3, ECL_SYM("MACROLET",521), VV[241], T4);
   return value0;
L24:;
   T0 = L7putify(1, v6stuff);
   value0 = cl_list(3, T0, ecl_make_fixnum(1), v5thing);
   return value0;
L22:;
   value0 = cl_list(3, VV[48], ecl_make_fixnum(1), v5thing);
   return value0;
  }
 }
}
/*      local function DATA-PUT-PREDICATING                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC99data_put_predicating(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5thing;
   cl_object v6stuff;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5thing = v7;
   }
   if (Null(v3)) { goto L15; }
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6stuff = v7;
    goto L14;
   }
L15:;
   v6stuff = ECL_NIL;
L14:;
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   if (Null(v6stuff)) { goto L22; }
   T0 = cl_list(2, ECL_SYM("QUOTE",679), v6stuff);
   T1 = cl_list(3, VV[0], v5thing, T0);
   if (!(ECL_CONSP(v6stuff))) { goto L25; }
   T3 = ecl_car(v6stuff);
   T4 = L7putify(1, T3);
   T5 = ecl_cdr(v6stuff);
   T6 = cl_listX(4, T4, v4index, v5thing, T5);
   T7 = cl_list(3, VV[48], ecl_make_fixnum(1), T6);
   T2 = cl_list(3, ECL_SYM("MACROLET",521), VV[241], T7);
   goto L24;
L25:;
   T3 = L7putify(1, v6stuff);
   T2 = cl_list(3, T3, ecl_make_fixnum(1), v5thing);
L24:;
   value0 = cl_list(3, ECL_SYM("AND",87), T1, T2);
   return value0;
L22:;
   T0 = cl_list(3, VV[0], v5thing, VV[243]);
   T1 = cl_list(3, VV[48], ecl_make_fixnum(1), v5thing);
   value0 = cl_list(3, ECL_SYM("AND",87), T0, T1);
   return value0;
  }
 }
}
/*      local function OR-EXPAND                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC102or_expand(cl_object v1, cl_object v2environment)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v2environment,env0);         /*  ENVIRONMENT     */
  {
   cl_object v3;
   v3 = ecl_cdr(v1);
   {
    cl_object v4;
    {
     cl_object v5;
     v5 = ecl_make_cclosure_va((cl_objectfn)LC101__g1043,env0,Cblock);
     v4 = v5;
    }
    {
     cl_object v5;
     cl_object v6;
     v5 = ECL_NIL;
     {
      cl_object v7;
      v7 = v3;
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      v6 = v7;
     }
     {
      cl_object v7;
      cl_object v8;
      v7 = ecl_list1(ECL_NIL);
      v8 = v7;
L10:;
      if (!(ecl_endp(v6))) { goto L12; }
      goto L11;
L12:;
      v5 = _ecl_car(v6);
      {
       cl_object v9;
       v9 = _ecl_cdr(v6);
       if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
       v6 = v9;
      }
      {
       cl_object v9;
       v9 = v8;
       if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
       T1 = v9;
      }
      T2 = ecl_function_dispatch(cl_env_copy,v4)(1, v5);
      v8 = ecl_list1(T2);
      (ECL_CONS_CDR(T1)=v8,T1);
      goto L10;
L11:;
      T0 = ecl_cdr(v7);
      goto L2;
     }
    }
   }
L2:;
   value0 = CONS(ECL_SYM("COND",247),T0);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure G1043                                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC101__g1043(cl_narg narg, cl_object v1forms, ...)
{
 cl_object T0, T1;
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV0 = env0;                                     /*  ENVIRONMENT     */
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v2;
   {
    cl_object v3;
    v3 = ecl_make_cclosure_va((cl_objectfn)LC100__g1049,env0,Cblock);
    v2 = v3;
   }
   {
    cl_object v3;
    cl_object v4;
    v3 = ECL_NIL;
    {
     cl_object v5;
     v5 = v1forms;
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     v4 = v5;
    }
    {
     cl_object v5;
     cl_object v6;
     v5 = ecl_list1(ECL_NIL);
     v6 = v5;
L8:;
     if (!(ecl_endp(v4))) { goto L10; }
     goto L9;
L10:;
     v3 = _ecl_car(v4);
     {
      cl_object v7;
      v7 = _ecl_cdr(v4);
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      v4 = v7;
     }
     {
      cl_object v7;
      v7 = v6;
      if (ecl_unlikely(ECL_ATOM(v7))) FEtype_error_cons(v7);
      T0 = v7;
     }
     T1 = ecl_function_dispatch(cl_env_copy,v2)(1, v3);
     v6 = ecl_list1(T1);
     (ECL_CONS_CDR(T0)=v6,T0);
     goto L8;
L9:;
     value0 = ecl_cdr(v5);
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
 }
}
/*      closure G1049                                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC100__g1049(cl_narg narg, cl_object v1form, ...)
{
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV0 = env0;                                     /*  ENVIRONMENT     */
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[565])(2, v1form, ECL_CONS_CAR(CLV0)) /*  CLX-MACROEXPAND */;
  return value0;
 }
 }
}
/*      local function OR-GET                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC103or_get(cl_object v1, cl_object v2environment)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v5;
   }
   {
    cl_object v5;
    cl_object v6types;
    cl_object v7result;
    v5 = cl_gensym(0);
    v6types = v3;
    v7result = ECL_NIL;
    goto L13;
L12:;
    {
     cl_object v8;
     cl_object v9item;
     cl_object v10args;
     v8 = ecl_car(v6types);
     v9item = v8;
     v10args = ECL_NIL;
     if (!(ECL_CONSP(v9item))) { goto L19; }
     v10args = ecl_cdr(v9item);
     v9item = ecl_car(v9item);
L19:;
     if (!((v9item)==(ECL_SYM("NULL",605)))) { goto L24; }
     T0 = cl_list(2, ECL_SYM("ZEROP",926), v5);
     T1 = cl_list(2, T0, ECL_NIL);
     v7result = CONS(T1,v7result);
     goto L15;
L24:;
     T0 = L6getify(v9item);
     T1 = cl_listX(3, T0, v4index, v10args);
     T2 = ecl_list1(T1);
     v7result = CONS(T2,v7result);
    }
L15:;
    v6types = ecl_cdr(v6types);
L13:;
    if (ecl_endp(v6types)) { goto L30; }
    goto L12;
L30:;
    T0 = cl_list(2, VV[31], v4index);
    T1 = cl_list(2, v5, T0);
    T2 = ecl_list1(T1);
    T3 = cl_list(2, ECL_SYM("QUOTE",679), v5);
    T4 = cl_list(4, VV[31], VV[246], VV[247], T3);
    T5 = cl_list(2, ECL_SYM("QUOTE",679), v5);
    T6 = cl_list(4, VV[36], VV[246], VV[247], T5);
    T7 = cl_list(2, T4, T6);
    T8 = cl_nreverse(v7result);
    T9 = CONS(VV[245],T8);
    T10 = ecl_function_dispatch(cl_env_copy,VV[565])(2, T9, v2environment) /*  CLX-MACROEXPAND */;
    T11 = cl_list(3, ECL_SYM("MACROLET",521), T7, T10);
    value0 = cl_list(3, ECL_SYM("LET",477), T2, T11);
    return value0;
   }
  }
 }
}
/*      local function OR-PUT                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC104or_put(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   {
    cl_object v6types;
    cl_object v7result;
    v6types = v3;
    v7result = ECL_NIL;
    goto L18;
L17:;
    {
     cl_object v8type;
     cl_object v9type_name;
     cl_object v10args;
     v8type = ecl_car(v6types);
     v9type_name = v8type;
     v10args = ECL_NIL;
     if (!(ECL_CONSP(v8type))) { goto L24; }
     v10args = ecl_cdr(v8type);
     v9type_name = ecl_car(v8type);
L24:;
     if (Null(ecl_get(v9type_name,VV[135],ECL_NIL))) { goto L31; }
     T0 = ECL_NIL;
     goto L30;
L31:;
     goto L35;
     if (Null(ecl_cdr(v6types))) { goto L33; }
     goto L34;
L35:;
L34:;
     T1 = cl_list(2, ECL_SYM("QUOTE",679), v8type);
     T2 = cl_list(3, VV[0], v5value, T1);
     T0 = ecl_list1(T2);
     goto L30;
L33:;
     T0 = VV[249];
L30:;
     T1 = ecl_get(v9type_name,VV[135],ECL_NIL);
     T2 = L7putify(2, v9type_name, T1);
     T3 = cl_listX(4, T2, v4index, v5value, v10args);
     T4 = ecl_list1(T3);
     T5 = ecl_append(T0,T4);
     v7result = CONS(T5,v7result);
    }
    v6types = ecl_cdr(v6types);
L18:;
    if (ecl_endp(v6types)) { goto L39; }
    goto L17;
L39:;
    T0 = cl_nreverse(v7result);
    T1 = CONS(ECL_SYM("OR",614),v3);
    T2 = cl_list(2, ECL_SYM("QUOTE",679), T1);
    T3 = cl_list(3, VV[1], v5value, T2);
    T4 = cl_list(2, ECL_T, T3);
    T5 = ecl_list1(T4);
    T6 = ecl_append(T0,T5);
    value0 = CONS(ECL_SYM("COND",247),T6);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for MASK-GET                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L107mask_get(cl_object v1index, cl_object v2type_values, cl_object v3body_function)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 cl_object env0 = ECL_NIL;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v3body_function,env0);       /*  BODY-FUNCTION   */
  {
   cl_object v4result;
   cl_object env1 = env0;
   CLV1 = env1 = CONS(ecl_make_fixnum(0),env1);   /*  BIT             */
   {
    cl_object v5;
    {
     cl_object v6;
     v6 = ecl_make_cclosure_va((cl_objectfn)LC105__g1116,env1,Cblock);
     v5 = v6;
    }
    {
     cl_object v6;
     cl_object v7;
     cl_object v8;
     T0 = ecl_plus(v1index,ecl_make_fixnum(4));
     {
      cl_object v9;
      v9 = ecl_make_cclosure_va((cl_objectfn)LC106__g1122,env1,Cblock);
      T1 = v9;
     }
     v6 = L115get_put_items(4, T0, v2type_values, ECL_NIL, T1);
     v7 = ECL_NIL;
     {
      cl_object v9;
      v9 = v6;
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      v8 = v9;
     }
     {
      cl_object v9;
      cl_object v10;
      v9 = ecl_list1(ECL_NIL);
      v10 = v9;
L11:;
      if (!(ecl_endp(v8))) { goto L13; }
      goto L12;
L13:;
      v7 = _ecl_car(v8);
      {
       cl_object v11;
       v11 = _ecl_cdr(v8);
       if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
       v8 = v11;
      }
      {
       cl_object v11;
       v11 = v10;
       if (ecl_unlikely(ECL_ATOM(v11))) FEtype_error_cons(v11);
       T0 = v11;
      }
      T1 = ecl_function_dispatch(cl_env_copy,v5)(1, v7);
      v10 = ecl_list1(T1);
      (ECL_CONS_CDR(T0)=v10,T0);
      goto L11;
L12:;
      v4result = ecl_cdr(v9);
      goto L1;
     }
    }
   }
L1:;
   T1 = ecl_car(v4result);
   if (!(ECL_ATOM(T1))) { goto L30; }
   {
    cl_object v5;
    v5 = v4result;
    {
     cl_object v6;
     v6 = v5;
     if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
    }
    if (Null(v5)) { goto L37; }
    {
     cl_object v6;
     v6 = ECL_CONS_CDR(v5);
     v4result = v6;
     v5 = ECL_CONS_CAR(v5);
    }
L37:;
    T1 = v5;
   }
   T0 = ecl_list1(T1);
   goto L29;
L30:;
   T0 = ECL_NIL;
L29:;
   T1 = cl_list(2, VV[31], v1index);
   T2 = cl_list(3, ECL_SYM("SETQ",751), VV[252], T1);
   T3 = ecl_ceiling2(v1index,ecl_make_fixnum(4));
   T4 = cl_list(3, ECL_SYM("SETQ",751), VV[254], T3);
   T5 = ecl_car(v4result);
   T6 = cl_list(4, ECL_SYM("PROGN",671), T2, T4, T5);
   T7 = ecl_cdr(v4result);
   T8 = CONS(T6,T7);
   value0 = ecl_append(T0,T8);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure G1116                                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC105__g1116(cl_narg narg, cl_object v1form, ...)
{
 cl_object T0, T1;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  BIT             */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  if (!(ECL_ATOM(v1form))) { goto L1; }
  value0 = v1form;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  {
   cl_object v2;
   T0 = ECL_CONS_CAR(CLV1);
   T1 = cl_list(3, ECL_SYM("LOGBITP",495), T0, VV[252]);
   v2 = cl_list(3, ECL_SYM("WHEN",905), T1, v1form);
   T0 = ECL_CONS_CAR(CLV1);
   ECL_CONS_CAR(CLV1) = ecl_plus(T0,ecl_make_fixnum(1));
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      closure G1122                                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC106__g1122(cl_narg narg, cl_object v1type, cl_object v2index, cl_object v3item, cl_object v4args, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;
 CLV0 = _ecl_cdr(CLV1);                           /*  BODY-FUNCTION   */
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=4)) FEwrong_num_arguments_anonym();
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,ECL_CONS_CAR(CLV0))(4, v1type, VV[253], v3item, v4args);
  return value0;
 }
 }
}
/*      function definition for MASK-PUT                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L109mask_put(cl_object v1index, cl_object v2type_values, cl_object v3body_function)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 cl_object env0 = ECL_NIL;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v3body_function,env0);       /*  BODY-FUNCTION   */
  T0 = cl_list(2, VV[254], v1index);
  T1 = cl_list(2, VV[256], T0);
  {
   cl_object env1 = env0;
   CLV1 = env1 = CONS(ecl_make_fixnum(1),env1);   /*  BIT             */
   {
    cl_object v4;
    v4 = ecl_make_cclosure_va((cl_objectfn)LC108__g1125,env1,Cblock);
    T3 = v4;
   }
   T2 = L115get_put_items(4, v1index, v2type_values, ECL_T, T3);
  }
  T3 = cl_list(3, VV[33], v1index, VV[252]);
  T4 = CONS(T3,VV[260]);
  T5 = ecl_append(T2,T4);
  T6 = cl_listX(3, ECL_SYM("LET",477), T1, T5);
  value0 = ecl_list1(T6);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      closure G1125                                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC108__g1125(cl_narg narg, cl_object v1type, cl_object v2index, cl_object v3item, cl_object v4args, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  BIT             */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=4)) FEwrong_num_arguments_anonym();
 {
TTL:
  if (ECL_SYMBOLP(v3item)) { goto L3; }
  if (Null(cl_constantp(1, v3item))) { goto L1; }
  goto L2;
L3:;
L2:;
  T0 = cl_list(2, ECL_SYM("NULL",605), v3item);
  {
   cl_object v5;
   v5 = ECL_CONS_CAR(CLV1);
   {
    cl_object v6;
    T2 = ECL_CONS_CAR(CLV1);
    v6 = cl_ash(T2, ecl_make_fixnum(1));
    ECL_CONS_CAR(CLV1) = v6;
   }
   T1 = v5;
  }
  T2 = cl_list(3, ECL_SYM("LOGIOR",500), VV[252], T1);
  T3 = cl_list(3, ECL_SYM("SETQ",751), VV[252], T2);
  T4 = ecl_function_dispatch(cl_env_copy,ECL_CONS_CAR(CLV0))(4, v1type, VV[257], v3item, v4args);
  T5 = cl_listX(4, ECL_SYM("UNLESS",883), T0, T3, T4);
  value0 = ecl_list1(T5);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  T0 = cl_list(2, VV[258], v3item);
  T1 = ecl_list1(T0);
  {
   cl_object v5;
   v5 = ECL_CONS_CAR(CLV1);
   {
    cl_object v6;
    T3 = ECL_CONS_CAR(CLV1);
    v6 = cl_ash(T3, ecl_make_fixnum(1));
    ECL_CONS_CAR(CLV1) = v6;
   }
   T2 = v5;
  }
  T3 = cl_list(3, ECL_SYM("LOGIOR",500), VV[252], T2);
  T4 = cl_list(3, ECL_SYM("SETQ",751), VV[252], T3);
  T5 = ecl_function_dispatch(cl_env_copy,ECL_CONS_CAR(CLV0))(4, v1type, VV[257], VV[258], v4args);
  T6 = cl_listX(4, ECL_SYM("UNLESS",883), VV[259], T4, T5);
  T7 = cl_list(3, ECL_SYM("LET",477), T1, T6);
  value0 = ecl_list1(T7);
  cl_env_copy->nvalues = 1;
  return value0;
 }
 }
}
/*      local function PROGN-GET                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC110progn_get(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5statement;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5statement = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = v5statement;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function PROGN-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC111progn_put(cl_object v1, cl_object v2)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5statement;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5statement = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   value0 = v5statement;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function CHECK-PUT                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC112check_put(cl_object v1, cl_object v2env)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4index;
   cl_object v5value;
   cl_object v6type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6type = v7;
   }
   {
    cl_object v7var;
    cl_object v8body;
    if (ECL_SYMBOLP(v5value)) { goto L23; }
    if (Null(cl_constantp(1, v5value))) { goto L21; }
    goto L22;
L23:;
L22:;
    v7var = v5value;
    goto L20;
L21:;
    v7var = VV[264];
L20:;
    T0 = cl_list(2, ECL_SYM("QUOTE",679), v6type);
    T1 = cl_list(3, VV[2], v7var, T0);
    T2 = cl_macroexpand(2, T1, v2env);
    if (T2==ECL_NIL) { goto L28; }
    if (!((v6type)==(ECL_SYM("OR",614)))) { goto L33; }
    goto L28;
    goto L31;
L33:;
    goto L31;
L31:;
    if (!((v6type)==(ECL_SYM("PROGN",671)))) { goto L37; }
    goto L28;
    goto L35;
L37:;
    goto L35;
L35:;
    if (!((v6type)==(VV[164]))) { goto L41; }
    goto L28;
    goto L39;
L41:;
    goto L39;
L39:;
    if (!((v6type)==(VV[167]))) { goto L44; }
    goto L28;
    goto L30;
L44:;
    goto L30;
L30:;
    if (Null(cl_constantp(1, v5value))) { goto L26; }
    goto L27;
L28:;
L27:;
    T0 = L7putify(1, v6type);
    v8body = cl_listX(4, T0, v4index, v7var, v3);
    goto L25;
L26:;
    if (Null(ecl_get(v6type,VV[135],ECL_NIL))) { goto L46; }
    T0 = L7putify(2, v6type, ECL_T);
    T1 = cl_listX(4, T0, v4index, v7var, v3);
    if (Null(v3)) { goto L49; }
    T2 = CONS(v6type,v3);
    goto L48;
L49:;
    T2 = v6type;
L48:;
    T3 = cl_list(2, ECL_SYM("QUOTE",679), T2);
    T4 = cl_list(3, VV[1], v7var, T3);
    v8body = cl_list(3, ECL_SYM("OR",614), T1, T4);
    goto L25;
L46:;
    T0 = cl_list(2, ECL_SYM("QUOTE",679), v6type);
    T1 = cl_list(3, VV[0], v7var, T0);
    T2 = L7putify(1, v6type);
    T3 = cl_listX(4, T2, v4index, v7var, v3);
    if (Null(v3)) { goto L52; }
    T4 = CONS(v6type,v3);
    goto L51;
L52:;
    T4 = v6type;
L51:;
    T5 = cl_list(2, ECL_SYM("QUOTE",679), T4);
    T6 = cl_list(3, VV[1], v7var, T5);
    v8body = cl_list(4, ECL_SYM("IF",946), T1, T3, T6);
L25:;
    if (!((v7var)==(v5value))) { goto L54; }
    value0 = v8body;
    cl_env_copy->nvalues = 1;
    return value0;
L54:;
    T0 = cl_list(2, v7var, v5value);
    T1 = ecl_list1(T0);
    value0 = cl_list(3, ECL_SYM("LET",477), T1, v8body);
    return value0;
   }
  }
 }
}
/*      function definition for GET-PUT-ITEMS                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L115get_put_items(cl_narg narg, cl_object v1index, cl_object v2type_args, cl_object v3putp, ...)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v4body_function;
  va_list args; va_start(args,v3putp);
  {
   int i = 3;
   if (i >= narg) {
    v4body_function = ECL_NIL;
   } else {
    i++;
    v4body_function = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if ((v4body_function)!=ECL_NIL) { goto L2; }
  {
   cl_object v5;
   {
    cl_object v6;
    v6 = ecl_make_cfun((cl_objectfn_fixed)LC114__g1158,ECL_NIL,Cblock,4);
    v5 = v6;
   }
   value0 = ecl_make_bool(v5==ECL_NIL);
   if ((value0)!=ECL_NIL) { goto L9; }
   T0 = cl_functionp(v5);
   goto L7;
L9:;
   T0 = value0;
   goto L7;
L7:;
   if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[270],v5);
   v4body_function = v5;
  }
L2:;
  {
   cl_object v5items;
   cl_object v6type;
   cl_object v7args;
   cl_object v8result;
   cl_object v9sizes;
   v5items = v2type_args;
   v6type = ecl_caar(v5items);
   v7args = ECL_NIL;
   v8result = ECL_NIL;
   v9sizes = ECL_NIL;
   goto L18;
L17:;
   if (!(ECL_CONSP(v6type))) { goto L20; }
   v7args = ecl_cdr(v6type);
   v6type = ecl_car(v6type);
L20:;
   {
    cl_object v10;
    if (!((v6type)==(ECL_SYM("RETURN",724)))) { goto L31; }
    value0 = VV[271];
    goto L29;
L31:;
    value0 = ECL_NIL;
    goto L29;
L29:;
    if ((value0)!=ECL_NIL) { goto L28; }
    if (!((v6type)==(VV[272]))) { goto L34; }
    v10 = VV[273];
    goto L26;
L34:;
    v10 = ECL_NIL;
    goto L26;
L28:;
    v10 = value0;
    goto L26;
L26:;
    if (Null(v10)) { goto L36; }
    goto L25;
L36:;
    if (!((v6type)==(VV[251]))) { goto L38; }
    if (Null(v3putp)) { goto L43; }
    T1 = ecl_cdar(v5items);
    T0 = L109mask_put(v1index, T1, v4body_function);
    goto L42;
L43:;
    T1 = ecl_cdar(v5items);
    T0 = L107mask_get(v1index, T1, v4body_function);
L42:;
    v8result = ecl_append(v8result,T0);
    v1index = ECL_NIL;
    goto L25;
L38:;
    {
     cl_object v11item;
     cl_object v12increment;
     v11item = ecl_cdar(v5items);
     v12increment = L5index_increment(v6type);
     goto L50;
L49:;
     if (Null(cl_constantp(1, v1index))) { goto L52; }
     if (!((v12increment)==(ecl_make_fixnum(2)))) { goto L54; }
     {
      cl_fixnum v13;
      {
       cl_fixnum v14;
       {
        cl_object v15;
        {
         cl_fixnum v16;
         {
          cl_object v17;
          v17 = v1index;
          {
          cl_fixnum v18;
          v18 = 0;
          if (!(ECL_FIXNUMP(v17))) { goto L66; }
          v18 = ecl_fixnum(v17);
          if (!((v18)<=(536870911))) { goto L71; }
          T0 = ecl_make_bool((v18)>=(0));
          goto L63;
L71:;
          T0 = ECL_NIL;
          goto L63;
L66:;
          T0 = ECL_NIL;
          goto L63;
          }
L63:;
          if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v17);
          v16 = ecl_fixnum(v17);
         }
         v15 = ecl_plus(ecl_make_fixnum(v16),ecl_make_fixnum(1));
        }
        {
         cl_fixnum v16;
         v16 = 0;
         if (!(ECL_FIXNUMP(v15))) { goto L77; }
         v16 = ecl_fixnum(v15);
         if (!((v16)<=(536870911))) { goto L82; }
         T0 = ecl_make_bool((v16)>=(0));
         goto L74;
L82:;
         T0 = ECL_NIL;
         goto L74;
L77:;
         T0 = ECL_NIL;
         goto L74;
        }
L74:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v15);
        v14 = ecl_fixnum(v15);
       }
       v13 = ((v14) & (-2));
      }
      {
       cl_fixnum v14;
       v14 = 0;
       v14 = v13;
       if (!((v14)<=(536870911))) { goto L93; }
       T0 = ecl_make_bool((v14)>=(0));
       goto L85;
L93:;
       T0 = ECL_NIL;
       goto L85;
       T0 = ECL_NIL;
       goto L85;
      }
L85:;
      if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],ecl_make_fixnum(v13));
      v1index = ecl_make_fixnum(v13);
     }
     goto L52;
L54:;
     if (!((v12increment)==(ecl_make_fixnum(4)))) { goto L52; }
     {
      cl_fixnum v13;
      {
       cl_fixnum v14;
       {
        cl_object v15;
        {
         cl_fixnum v16;
         {
          cl_object v17;
          v17 = v1index;
          {
          cl_fixnum v18;
          v18 = 0;
          if (!(ECL_FIXNUMP(v17))) { goto L106; }
          v18 = ecl_fixnum(v17);
          if (!((v18)<=(536870911))) { goto L111; }
          T0 = ecl_make_bool((v18)>=(0));
          goto L103;
L111:;
          T0 = ECL_NIL;
          goto L103;
L106:;
          T0 = ECL_NIL;
          goto L103;
          }
L103:;
          if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v17);
          v16 = ecl_fixnum(v17);
         }
         v15 = ecl_plus(ecl_make_fixnum(v16),ecl_make_fixnum(3));
        }
        {
         cl_fixnum v16;
         v16 = 0;
         if (!(ECL_FIXNUMP(v15))) { goto L117; }
         v16 = ecl_fixnum(v15);
         if (!((v16)<=(536870911))) { goto L122; }
         T0 = ecl_make_bool((v16)>=(0));
         goto L114;
L122:;
         T0 = ECL_NIL;
         goto L114;
L117:;
         T0 = ECL_NIL;
         goto L114;
        }
L114:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v15);
        v14 = ecl_fixnum(v15);
       }
       v13 = ((v14) & (-4));
      }
      {
       cl_fixnum v14;
       v14 = 0;
       v14 = v13;
       if (!((v14)<=(536870911))) { goto L133; }
       T0 = ecl_make_bool((v14)>=(0));
       goto L125;
L133:;
       T0 = ECL_NIL;
       goto L125;
       T0 = ECL_NIL;
       goto L125;
      }
L125:;
      if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],ecl_make_fixnum(v13));
      v1index = ecl_make_fixnum(v13);
     }
L52:;
     T1 = ecl_car(v11item);
     T0 = ecl_function_dispatch(cl_env_copy,v4body_function)(4, v6type, v1index, T1, v7args);
     v8result = ecl_append(v8result,T0);
     if (Null(cl_constantp(1, v1index))) { goto L138; }
     if (!(v12increment==ECL_NIL)) { goto L140; }
     v1index = ECL_NIL;
     goto L138;
L140:;
     v1index = ecl_plus(v1index,v12increment);
     if (Null(v12increment)) { goto L145; }
     if (!(ecl_zerop(v12increment))) { goto L145; }
     v12increment = ecl_make_fixnum(1);
L145:;
     T0 = ecl_times(v12increment,ecl_make_fixnum(8));
     v9sizes = cl_adjoin(2, T0, v9sizes);
L138:;
     v11item = ecl_cdr(v11item);
L50:;
     if (ecl_endp(v11item)) { goto L152; }
     goto L49;
L152:;
    }
   }
L25:;
   v5items = ecl_cdr(v5items);
   v6type = ecl_caar(v5items);
   v7args = ECL_NIL;
L18:;
   if (ecl_endp(v5items)) { goto L160; }
   goto L17;
L160:;
   cl_env_copy->nvalues = 3;
   cl_env_copy->values[2] = v9sizes;
   cl_env_copy->values[1] = v1index;
   cl_env_copy->values[0] = v8result;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function G1158                                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC114__g1158(cl_object v1type, cl_object v2index, cl_object v3item, cl_object v4args)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_listX(5, VV[269], v2index, v3item, v1type, v4args);
  value0 = ecl_list1(T0);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function WITH-BUFFER-REQUEST-INTERNAL                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC116with_buffer_request_internal(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6buffer;
   cl_object v7opcode;
   cl_object v8;
   cl_object v9length;
   cl_object v10;
   cl_object v11sizes;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v12;
    v12 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v12;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v12;
    v12 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6buffer = v12;
   }
   if (!(v5==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v12;
    v12 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v7opcode = v12;
   }
   v8 = si_search_keyword(2, v5, ECL_SYM("LENGTH",1266));
   if (!((v8)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L23; }
   v9length = ECL_NIL;
   goto L22;
L23:;
   v9length = v8;
L22:;
   v10 = si_search_keyword(2, v5, VV[275]);
   if (!((v10)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L27; }
   v11sizes = ECL_NIL;
   goto L26;
L27:;
   v11sizes = v10;
L26:;
   si_check_keyword(3, v5, VV[276], ECL_T);
   {
    cl_object v13;                                /*  CODE            */
    cl_object v14;                                /*  INDEX           */
    cl_object v15;                                /*  ITEM-SIZES      */
    value0 = L115get_put_items(3, ecl_make_fixnum(4), v3, ECL_T);
    v13 = value0;
    {
     const int v16 = cl_env_copy->nvalues;
     cl_object v17;
     v17 = (v16<=1)? ECL_NIL : cl_env_copy->values[1];
     v14 = v17;
     v17 = (v16<=2)? ECL_NIL : cl_env_copy->values[2];
     v15 = v17;
    }
    {
     cl_object v16;
     cl_object v17;
     if (Null(v9length)) { goto L32; }
     v16 = cl_list(3, VV[9], v9length, VV[277]);
     goto L31;
L32:;
     v16 = VV[277];
L31:;
     T0 = cl_append(3, VV[278], v15, v11sizes);
     v17 = cl_remove_duplicates(1, T0);
     T0 = cl_list(5, v6buffer, ECL_SYM("LENGTH",1266), v16, VV[275], v17);
     T1 = cl_list(2, VV[280], v6buffer);
     T2 = cl_list(3, ECL_SYM("SETF",750), T1, VV[178]);
     T3 = cl_list(3, VV[48], ecl_make_fixnum(0), v7opcode);
     if (Null(v14)) { goto L36; }
     {
      cl_fixnum v18;
      {
       cl_fixnum v19;
       {
        cl_object v20;
        {
         cl_fixnum v21;
         {
          cl_object v22;
          v22 = v14;
          {
          cl_fixnum v23;
          v23 = 0;
          if (!(ECL_FIXNUMP(v22))) { goto L49; }
          v23 = ecl_fixnum(v22);
          if (!((v23)<=(536870911))) { goto L54; }
          T5 = ecl_make_bool((v23)>=(0));
          goto L46;
L54:;
          T5 = ECL_NIL;
          goto L46;
L49:;
          T5 = ECL_NIL;
          goto L46;
          }
L46:;
          if (ecl_unlikely(!((T5)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v22);
          v21 = ecl_fixnum(v22);
         }
         v20 = ecl_plus(ecl_make_fixnum(v21),ecl_make_fixnum(3));
        }
        {
         cl_fixnum v21;
         v21 = 0;
         if (!(ECL_FIXNUMP(v20))) { goto L60; }
         v21 = ecl_fixnum(v20);
         if (!((v21)<=(536870911))) { goto L65; }
         T5 = ecl_make_bool((v21)>=(0));
         goto L57;
L65:;
         T5 = ECL_NIL;
         goto L57;
L60:;
         T5 = ECL_NIL;
         goto L57;
        }
L57:;
        if (ecl_unlikely(!((T5)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],v20);
        v19 = ecl_fixnum(v20);
       }
       v18 = ((v19) & (-4));
      }
      {
       cl_fixnum v19;
       v19 = 0;
       v19 = v18;
       if (!((v19)<=(536870911))) { goto L76; }
       T5 = ecl_make_bool((v19)>=(0));
       goto L68;
L76:;
       T5 = ECL_NIL;
       goto L68;
       T5 = ECL_NIL;
       goto L68;
      }
L68:;
      if (ecl_unlikely(!((T5)!=ECL_NIL)))
         FEwrong_type_argument(VV[8],ecl_make_fixnum(v18));
      v14 = ecl_make_fixnum(v18);
     }
     T5 = ecl_ceiling2(v14,ecl_make_fixnum(4));
     T6 = cl_list(3, VV[43], ecl_make_fixnum(2), T5);
     T7 = cl_list(2, VV[178], v6buffer);
     T8 = cl_list(3, VV[9], VV[178], v14);
     T9 = cl_list(3, ECL_SYM("SETF",750), T7, T8);
     T4 = cl_list(2, T6, T9);
     goto L35;
L36:;
     T4 = ECL_NIL;
L35:;
     T5 = cl_list(2, VV[281], v6buffer);
     T6 = ecl_list1(T5);
     T7 = cl_append(3, v13, T4, T6);
     value0 = cl_listX(5, VV[279], T0, T2, T3, T7);
     return value0;
    }
   }
  }
 }
}
/*      local function WITH-BUFFER-REQUEST                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC117with_buffer_request(cl_object v1, cl_object v2env)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6buffer;
   cl_object v7opcode;
   cl_object v8;
   cl_object v9inline;
   cl_object v10;
   cl_object v11gc_force;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v12;
    v12 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v12;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v12;
    v12 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6buffer = v12;
   }
   if (!(v5==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v12;
    v12 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v7opcode = v12;
   }
   v8 = si_search_keyword(2, v5, VV[283]);
   if (!((v8)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L23; }
   v9inline = ECL_NIL;
   goto L22;
L23:;
   v9inline = v8;
L22:;
   v10 = si_search_keyword(2, v5, VV[284]);
   if (!((v10)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L27; }
   v11gc_force = ECL_NIL;
   goto L26;
L27:;
   v11gc_force = v10;
L26:;
   si_check_keyword(3, v5, VV[285], ECL_T);
   if (!(v9inline==ECL_NIL)) { goto L30; }
   if (Null(cl_macroexpand(2, VV[286], v2env))) { goto L30; }
   T0 = cl_listX(3, VV[290], v7opcode, v5);
   T1 = cl_listX(3, VV[282], T0, v3);
   T2 = cl_list(4, VV[287], VV[288], VV[289], T1);
   T3 = ecl_list1(T2);
   T5 = cl_macroexpand(2, VV[292], v2env);
   T6 = ecl_car(T5);
   if (!((T6)==(ECL_SYM("PROGN",671)))) { goto L34; }
   T4 = VV[293];
   goto L33;
L34:;
   T4 = VV[294];
L33:;
   T5 = cl_list(4, T4, v6buffer, v11gc_force, VV[295]);
   value0 = cl_list(4, ECL_SYM("FLET",373), T3, VV[291], T5);
   return value0;
L30:;
   T0 = cl_list(2, VV[290], v6buffer);
   T1 = ecl_list1(T0);
   if (Null(v11gc_force)) { goto L37; }
   T3 = cl_list(2, VV[297], v11gc_force);
   T2 = ecl_list1(T3);
   goto L36;
L37:;
   T2 = ECL_NIL;
L36:;
   T3 = cl_listX(3, VV[290], v7opcode, v5);
   T4 = cl_listX(3, VV[282], T3, v3);
   T5 = cl_list(2, VV[298], T4);
   T6 = cl_list(3, ECL_SYM("MULTIPLE-VALUE-PROG1",575), T5, VV[299]);
   T7 = ecl_list1(T6);
   T8 = ecl_append(T2,T7);
   T9 = cl_listX(3, VV[296], VV[288], T8);
   value0 = cl_list(4, ECL_SYM("LET",477), T1, VV[289], T9);
   return value0;
  }
 }
}
/*      local function WITH-BUFFER-REQUEST-AND-REPLY                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC118with_buffer_request_and_reply(cl_object v1, cl_object v2env)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6buffer;
   cl_object v7opcode;
   cl_object v8reply_size;
   cl_object v9;
   cl_object v10sizes;
   cl_object v11;
   cl_object v12multiple_reply;
   cl_object v13;
   cl_object v14inline;
   cl_object v15type_args;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v16;
    v16 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v16;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v16;
    v16 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6buffer = v16;
   }
   if (!(v5==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v16;
    v16 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v7opcode = v16;
   }
   if (!(v5==ECL_NIL)) { goto L22; }
   si_dm_too_few_arguments(v1);
L22:;
   {
    cl_object v16;
    v16 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v8reply_size = v16;
   }
   v9 = si_search_keyword(2, v5, VV[275]);
   if (!((v9)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L29; }
   v10sizes = ECL_NIL;
   goto L28;
L29:;
   v10sizes = v9;
L28:;
   v11 = si_search_keyword(2, v5, VV[301]);
   if (!((v11)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L33; }
   v12multiple_reply = ECL_NIL;
   goto L32;
L33:;
   v12multiple_reply = v11;
L32:;
   v13 = si_search_keyword(2, v5, VV[283]);
   if (!((v13)==(ECL_SYM("MISSING-KEYWORD",1936)))) { goto L37; }
   v14inline = ECL_NIL;
   goto L36;
L37:;
   v14inline = v13;
L36:;
   if (!(v3==ECL_NIL)) { goto L40; }
   si_dm_too_few_arguments(v1);
L40:;
   {
    cl_object v16;
    v16 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v15type_args = v16;
   }
   si_check_keyword(2, v5, VV[302]);
   {
    cl_object v16inner_reply_body;
    cl_object v17reply_body;
    if (Null(v10sizes)) { goto L49; }
    T0 = cl_list(2, VV[275], v10sizes);
    goto L47;
L49:;
    T0 = ECL_NIL;
    goto L47;
L47:;
    T1 = cl_listX(4, VV[304], VV[305], VV[290], T0);
    v16inner_reply_body = cl_listX(4, VV[303], T1, ECL_NIL, v3);
    if (!(ECL_SYMBOLP(v8reply_size))) { goto L54; }
    if (Null(cl_constantp(1, v8reply_size))) { goto L52; }
    goto L53;
L54:;
L53:;
    v17reply_body = v16inner_reply_body;
    goto L51;
L52:;
    T0 = cl_list(2, v8reply_size, VV[306]);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("TYPE",869), VV[8], v8reply_size);
    T3 = cl_list(2, ECL_SYM("DECLARE",274), T2);
    v17reply_body = cl_list(4, ECL_SYM("LET",477), T1, T3, v16inner_reply_body);
L51:;
    if (!(v14inline==ECL_NIL)) { goto L56; }
    if (Null(cl_macroexpand(2, VV[286], v2env))) { goto L56; }
    T0 = cl_list(2, VV[290], v7opcode);
    T1 = cl_listX(3, VV[282], T0, v15type_args);
    T2 = cl_list(4, VV[287], VV[288], VV[289], T1);
    T3 = cl_list(5, VV[307], VV[308], VV[309], VV[310], v17reply_body);
    T4 = cl_list(2, T2, T3);
    T5 = cl_listX(4, VV[312], v6buffer, v12multiple_reply, VV[313]);
    value0 = cl_list(4, ECL_SYM("FLET",373), T4, VV[311], T5);
    return value0;
L56:;
    T0 = cl_list(2, VV[290], v6buffer);
    T1 = CONS(T0,VV[314]);
    T2 = cl_list(2, VV[290], v7opcode);
    T3 = cl_listX(3, VV[282], T2, v15type_args);
    T4 = cl_list(2, VV[298], T3);
    T5 = cl_listX(5, VV[296], VV[288], VV[316], T4, VV[317]);
    if (Null(v12multiple_reply)) { goto L60; }
    T7 = cl_list(3, ECL_SYM("WHEN",905), v17reply_body, VV[319]);
    T8 = cl_list(4, ECL_SYM("LOOP",512), VV[318], T7, VV[320]);
    T6 = ecl_list1(T8);
    goto L59;
L60:;
    T6 = cl_list(2, VV[318], v17reply_body);
L59:;
    T7 = cl_listX(3, ECL_SYM("PROGN",671), T5, T6);
    T8 = cl_listX(3, ECL_SYM("UNWIND-PROTECT",888), T7, VV[321]);
    value0 = cl_list(4, ECL_SYM("LET",477), T1, VV[315], T8);
    return value0;
   }
  }
 }
}
/*      local function COMPARE-REQUEST                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC119compare_request(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v7;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v7;
    v7 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6index = v7;
   }
   if (Null(v5)) { goto L15; }
   si_dm_too_many_arguments(v1);
L15:;
   T0 = L115get_put_items(3, v6index, v3, ECL_T);
   T1 = CONS(ECL_SYM("AND",87),T0);
   T2 = cl_list(3, ECL_SYM("MACROLET",521), VV[324], T1);
   value0 = cl_list(3, ECL_SYM("MACROLET",521), VV[323], T2);
   return value0;
  }
 }
}
/*      local function PUT-ITEMS                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC120put_items(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v7;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v7;
    v7 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6index = v7;
   }
   if (Null(v5)) { goto L15; }
   si_dm_too_many_arguments(v1);
L15:;
   T0 = L115get_put_items(3, v6index, v3, ECL_T);
   value0 = CONS(ECL_SYM("PROGN",671),T0);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function DECODE-TYPE                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC121decode_type(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4type;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4type = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   {
    cl_object v6args;
    v6args = ECL_NIL;
    if (!(ECL_CONSP(v4type))) { goto L17; }
    v6args = ecl_cdr(v4type);
    v4type = ecl_car(v4type);
L17:;
    T0 = L6getify(v4type);
    T1 = cl_listX(3, T0, v5value, v6args);
    value0 = cl_list(3, ECL_SYM("MACROLET",521), VV[327], T1);
    return value0;
   }
  }
 }
}
/*      local function ENCODE-TYPE                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC122encode_type(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4type;
   cl_object v5value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4type = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5value = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   {
    cl_object v6args;
    v6args = ECL_NIL;
    if (!(ECL_CONSP(v4type))) { goto L17; }
    v6args = ecl_cdr(v4type);
    v4type = ecl_car(v4type);
L17:;
    T0 = cl_listX(5, VV[269], ecl_make_fixnum(0), v5value, v4type, v6args);
    value0 = cl_list(3, ECL_SYM("MACROLET",521), VV[329], T0);
    return value0;
   }
  }
 }
}
/*      local function SET-DECODE-TYPE                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC123set_decode_type(cl_object v1, cl_object v2)
{
 cl_object T0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4type;
   cl_object v5accessor;
   cl_object v6value;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4type = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5accessor = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6value = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   T0 = cl_list(3, VV[330], v4type, v6value);
   value0 = cl_list(3, ECL_SYM("SETF",750), v5accessor, T0);
   return value0;
  }
 }
}
/*      local function THREADED-ATOMIC-PUSH                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC124threaded_atomic_push(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5list;
   cl_object v6next;
   cl_object v7type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5list = v8;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6next = v8;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7type = v8;
   }
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   {
    cl_object v8;
    cl_object v9;
    v8 = cl_gensym(0);
    v9 = cl_gensym(0);
    T0 = cl_list(2, v8, v4item);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("TYPE",869), v7type, v8);
    T3 = cl_list(2, ECL_SYM("DECLARE",274), T2);
    T4 = cl_list(2, v9, v5list);
    T5 = ecl_list1(T4);
    T6 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T7 = cl_list(3, ECL_SYM("TYPE",869), T6, v9);
    T8 = cl_list(3, ECL_SYM("DECLARE",274), T7, VV[452]);
    T9 = cl_list(2, v6next, v8);
    T10 = cl_list(3, ECL_SYM("SETF",750), T9, v9);
    T11 = cl_list(4, VV[453], v5list, v9, v8);
    T12 = cl_list(2, ECL_SYM("RETURN",724), v8);
    T13 = cl_list(3, ECL_SYM("WHEN",905), T11, T12);
    T14 = cl_list(5, ECL_SYM("LET",477), T5, T8, T10, T13);
    T15 = cl_list(2, ECL_SYM("LOOP",512), T14);
    value0 = cl_list(4, ECL_SYM("LET",477), T1, T3, T15);
    return value0;
   }
  }
 }
}
/*      local function THREADED-ATOMIC-POP                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC125threaded_atomic_pop(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4list;
   cl_object v5next;
   cl_object v6type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4list = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5next = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6type = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   {
    cl_object v7y;
    v7y = cl_gensym(0);
    T0 = cl_list(2, v7y, v4list);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v6type);
    T3 = cl_list(3, ECL_SYM("TYPE",869), T2, v7y);
    T4 = cl_list(3, ECL_SYM("DECLARE",274), T3, VV[452]);
    T5 = cl_list(2, ECL_SYM("NULL",605), v7y);
    T6 = cl_list(3, ECL_SYM("THE",856), v6type, v7y);
    T7 = cl_list(2, v5next, T6);
    T8 = cl_list(4, VV[453], v4list, v7y, T7);
    T9 = cl_list(3, ECL_SYM("THE",856), v6type, v7y);
    T10 = cl_list(2, v5next, T9);
    T11 = cl_list(3, ECL_SYM("SETF",750), T10, ECL_NIL);
    T12 = cl_list(2, ECL_SYM("RETURN",724), v7y);
    T13 = cl_list(4, ECL_SYM("WHEN",905), T8, T11, T12);
    T14 = cl_list(4, ECL_SYM("IF",946), T5, VV[319], T13);
    T15 = cl_list(4, ECL_SYM("LET",477), T1, T4, T14);
    value0 = cl_list(2, ECL_SYM("LOOP",512), T15);
    return value0;
   }
  }
 }
}
/*      local function THREADED-NCONC                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC126threaded_nconc(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5list;
   cl_object v6next;
   cl_object v7type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5list = v8;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6next = v8;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7type = v8;
   }
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   {
    cl_object v8;
    cl_object v9;
    cl_object v10;
    cl_object v11;
    v8 = cl_gensym(0);
    v9 = cl_gensym(0);
    v10 = cl_gensym(0);
    v11 = cl_gensym(0);
    T0 = cl_list(2, v11, v4item);
    T1 = cl_list(2, v8, v5list);
    T2 = cl_list(2, T0, T1);
    T3 = cl_list(3, ECL_SYM("TYPE",869), v7type, v11);
    T4 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v8);
    T6 = cl_list(4, ECL_SYM("DECLARE",274), T3, T5, VV[452]);
    T7 = cl_list(2, ECL_SYM("NULL",605), v8);
    T8 = cl_list(3, ECL_SYM("SETF",750), v5list, v11);
    T9 = cl_list(3, v9, v8, v10);
    T10 = cl_list(2, v6next, v9);
    T11 = cl_list(2, v6next, v9);
    T12 = cl_list(3, v10, T10, T11);
    T13 = cl_list(2, T9, T12);
    T14 = cl_list(2, ECL_SYM("NULL",605), v10);
    T15 = cl_list(2, v6next, v9);
    T16 = cl_list(3, ECL_SYM("SETF",750), T15, v11);
    T17 = cl_list(3, T14, T16, v8);
    T18 = cl_list(3, ECL_SYM("TYPE",869), v7type, v9);
    T19 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T20 = cl_list(3, ECL_SYM("TYPE",869), T19, v10);
    T21 = cl_list(3, ECL_SYM("DECLARE",274), T18, T20);
    T22 = cl_list(4, ECL_SYM("DO*",308), T13, T17, T21);
    T23 = cl_list(4, ECL_SYM("IF",946), T7, T8, T22);
    value0 = cl_list(4, ECL_SYM("LET",477), T2, T6, T23);
    return value0;
   }
  }
 }
}
/*      local function THREADED-PUSH                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC127threaded_push(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5list;
   cl_object v6next;
   cl_object v7type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5list = v8;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6next = v8;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7type = v8;
   }
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   {
    cl_object v8x;
    v8x = cl_gensym(0);
    T0 = cl_list(2, v8x, v4item);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("TYPE",869), v7type, v8x);
    T3 = cl_list(3, ECL_SYM("DECLARE",274), T2, VV[452]);
    T4 = cl_list(2, v6next, v8x);
    T5 = cl_list(4, ECL_SYM("SHIFTF",755), T4, v5list, v8x);
    value0 = cl_list(5, ECL_SYM("LET",477), T1, T3, T5, v8x);
    return value0;
   }
  }
 }
}
/*      local function THREADED-POP                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC128threaded_pop(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4list;
   cl_object v5next;
   cl_object v6type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4list = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5next = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6type = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   {
    cl_object v7x;
    v7x = cl_gensym(0);
    T0 = cl_list(2, v7x, v4list);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v6type);
    T3 = cl_list(3, ECL_SYM("TYPE",869), T2, v7x);
    T4 = cl_list(3, ECL_SYM("DECLARE",274), T3, VV[452]);
    T5 = cl_list(3, ECL_SYM("THE",856), v6type, v7x);
    T6 = cl_list(2, v5next, T5);
    T7 = cl_list(4, ECL_SYM("SHIFTF",755), v4list, T6, ECL_NIL);
    T8 = cl_list(3, ECL_SYM("WHEN",905), v7x, T7);
    value0 = cl_list(5, ECL_SYM("LET",477), T1, T4, T8, v7x);
    return value0;
   }
  }
 }
}
/*      local function THREADED-ENQUEUE                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC129threaded_enqueue(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5head;
   cl_object v6tail;
   cl_object v7next;
   cl_object v8type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v9;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5head = v9;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6tail = v9;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7next = v9;
   }
   if (!(v3==ECL_NIL)) { goto L27; }
   si_dm_too_few_arguments(v1);
L27:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v8type = v9;
   }
   if (Null(v3)) { goto L32; }
   si_dm_too_many_arguments(v1);
L32:;
   {
    cl_object v9x;
    v9x = cl_gensym(0);
    T0 = cl_list(2, v9x, v4item);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("TYPE",869), v8type, v9x);
    T3 = cl_list(3, ECL_SYM("DECLARE",274), T2, VV[452]);
    T4 = cl_list(2, ECL_SYM("NULL",605), v6tail);
    T5 = cl_list(5, VV[456], v9x, v5head, v7next, v8type);
    T6 = cl_list(3, ECL_SYM("THE",856), v8type, v6tail);
    T7 = cl_list(2, v7next, T6);
    T8 = cl_list(5, VV[456], v9x, T7, v7next, v8type);
    T9 = cl_list(4, ECL_SYM("IF",946), T4, T5, T8);
    T10 = cl_list(3, ECL_SYM("SETF",750), v6tail, v9x);
    value0 = cl_list(5, ECL_SYM("LET",477), T1, T3, T9, T10);
    return value0;
   }
  }
 }
}
/*      local function THREADED-DEQUEUE                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC130threaded_dequeue(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4head;
   cl_object v5tail;
   cl_object v6next;
   cl_object v7type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4head = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5tail = v8;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6next = v8;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7type = v8;
   }
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   {
    cl_object v8x;
    v8x = cl_gensym(0);
    T0 = cl_list(2, v8x, v4head);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T3 = cl_list(3, ECL_SYM("TYPE",869), T2, v8x);
    T4 = cl_list(3, ECL_SYM("DECLARE",274), T3, VV[452]);
    T5 = cl_list(3, ECL_SYM("EQ",333), v8x, v5tail);
    T6 = cl_list(3, ECL_SYM("THE",856), v7type, v8x);
    T7 = cl_list(2, v6next, T6);
    T8 = cl_list(3, ECL_SYM("SETF",750), v5tail, T7);
    T9 = cl_list(3, ECL_SYM("WHEN",905), T5, T8);
    T10 = cl_list(3, ECL_SYM("THE",856), v7type, v8x);
    T11 = cl_list(2, v6next, T10);
    T12 = cl_list(3, ECL_SYM("SETF",750), v4head, T11);
    T13 = cl_list(4, ECL_SYM("WHEN",905), v8x, T9, T12);
    value0 = cl_list(5, ECL_SYM("LET",477), T1, T4, T13, v8x);
    return value0;
   }
  }
 }
}
/*      local function THREADED-REQUEUE                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC131threaded_requeue(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5head;
   cl_object v6tail;
   cl_object v7next;
   cl_object v8type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v9;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5head = v9;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6tail = v9;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7next = v9;
   }
   if (!(v3==ECL_NIL)) { goto L27; }
   si_dm_too_few_arguments(v1);
L27:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v8type = v9;
   }
   if (Null(v3)) { goto L32; }
   si_dm_too_many_arguments(v1);
L32:;
   {
    cl_object v9x;
    v9x = cl_gensym(0);
    T0 = cl_list(2, v9x, v4item);
    T1 = ecl_list1(T0);
    T2 = cl_list(3, ECL_SYM("TYPE",869), v8type, v9x);
    T3 = cl_list(3, ECL_SYM("DECLARE",274), T2, VV[452]);
    T4 = cl_list(2, ECL_SYM("NULL",605), v6tail);
    T5 = cl_list(3, ECL_SYM("SETF",750), v5head, v9x);
    T6 = cl_list(3, ECL_SYM("SETF",750), v6tail, T5);
    T7 = cl_list(2, v7next, v9x);
    T8 = cl_list(4, ECL_SYM("SHIFTF",755), T7, v5head, v9x);
    T9 = cl_list(4, ECL_SYM("IF",946), T4, T6, T8);
    value0 = cl_list(5, ECL_SYM("LET",477), T1, T3, T9, v9x);
    return value0;
   }
  }
 }
}
/*      local function THREADED-DOLIST                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC132threaded_dolist(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6variable;
   cl_object v7list;
   cl_object v8next;
   cl_object v9type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v10;
    v10 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v10;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v10;
    v10 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6variable = v10;
   }
   if (!(v5==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v10;
    v10 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v7list = v10;
   }
   if (!(v5==ECL_NIL)) { goto L22; }
   si_dm_too_few_arguments(v1);
L22:;
   {
    cl_object v10;
    v10 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v8next = v10;
   }
   if (!(v5==ECL_NIL)) { goto L28; }
   si_dm_too_few_arguments(v1);
L28:;
   {
    cl_object v10;
    v10 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v9type = v10;
   }
   if (Null(v5)) { goto L33; }
   si_dm_too_many_arguments(v1);
L33:;
   T0 = cl_list(3, ECL_SYM("THE",856), v9type, v6variable);
   T1 = cl_list(2, v8next, T0);
   T2 = cl_list(3, v6variable, v7list, T1);
   T3 = ecl_list1(T2);
   T4 = cl_list(2, ECL_SYM("NULL",605), v6variable);
   T5 = ecl_list1(T4);
   T6 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v9type);
   T7 = cl_list(3, ECL_SYM("TYPE",869), T6, v6variable);
   T8 = cl_list(2, ECL_SYM("DECLARE",274), T7);
   T9 = cl_listX(5, ECL_SYM("DO*",308), T3, T5, T8, v3);
   value0 = cl_list(3, ECL_SYM("BLOCK",137), ECL_NIL, T9);
   return value0;
  }
 }
}
/*      local function THREADED-DELETE                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC133threaded_delete(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28, T29, T30, T31, T32, T33, T34;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4item;
   cl_object v5list;
   cl_object v6next;
   cl_object v7type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4item = v8;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5list = v8;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6next = v8;
   }
   if (!(v3==ECL_NIL)) { goto L21; }
   si_dm_too_few_arguments(v1);
L21:;
   {
    cl_object v8;
    v8 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v7type = v8;
   }
   if (Null(v3)) { goto L26; }
   si_dm_too_many_arguments(v1);
L26:;
   {
    cl_object v8;
    cl_object v9;
    cl_object v10;
    cl_object v11;
    v8 = cl_gensym(0);
    v9 = cl_gensym(0);
    v10 = cl_gensym(0);
    v11 = cl_gensym(0);
    T0 = cl_list(2, v8, v4item);
    T1 = cl_list(2, v11, v5list);
    T2 = cl_list(2, T0, T1);
    T3 = cl_list(3, ECL_SYM("TYPE",869), v7type, v8);
    T4 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T5 = cl_list(3, ECL_SYM("TYPE",869), T4, v11);
    T6 = cl_list(4, ECL_SYM("DECLARE",274), T3, T5, VV[452]);
    T7 = cl_list(3, ECL_SYM("EQ",333), v11, v8);
    T8 = cl_list(2, v6next, v8);
    T9 = cl_list(3, ECL_SYM("SETF",750), v5list, T8);
    T10 = cl_list(3, ECL_SYM("SETF",750), v11, T9);
    T11 = cl_list(3, v9, v11, v10);
    T12 = cl_list(2, v6next, v9);
    T13 = cl_list(2, v6next, v9);
    T14 = cl_list(3, v10, T12, T13);
    T15 = cl_list(2, T11, T14);
    T16 = cl_list(2, ECL_SYM("NULL",605), v10);
    T17 = cl_list(3, ECL_SYM("EQ",333), v10, v8);
    T18 = cl_list(3, ECL_SYM("OR",614), T16, T17);
    T19 = cl_list(3, ECL_SYM("EQ",333), v10, v8);
    T20 = cl_list(2, v6next, v9);
    T21 = cl_list(2, v6next, v8);
    T22 = cl_list(3, ECL_SYM("SETF",750), T20, T21);
    T23 = cl_list(3, ECL_SYM("WHEN",905), T19, T22);
    T24 = cl_list(2, T18, T23);
    T25 = cl_list(3, ECL_SYM("TYPE",869), v7type, v9);
    T26 = cl_list(2, ECL_SYM("DECLARE",274), T25);
    T27 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v7type);
    T28 = cl_list(3, ECL_SYM("TYPE",869), T27, v10);
    T29 = cl_list(2, ECL_SYM("DECLARE",274), T28);
    T30 = cl_list(5, ECL_SYM("DO*",308), T15, T24, T26, T29);
    T31 = cl_list(4, ECL_SYM("IF",946), T7, T10, T30);
    T32 = cl_list(3, ECL_SYM("WHEN",905), v11, T31);
    T33 = cl_list(2, v6next, v8);
    T34 = cl_list(3, ECL_SYM("SETF",750), T33, ECL_NIL);
    value0 = cl_list(6, ECL_SYM("LET",477), T2, T6, T32, T34, v11);
    return value0;
   }
  }
 }
}
/*      local function THREADED-LENGTH                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC134threaded_length(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4list;
   cl_object v5next;
   cl_object v6type;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4list = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5next = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   si_dm_too_few_arguments(v1);
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6type = v7;
   }
   if (Null(v3)) { goto L20; }
   si_dm_too_many_arguments(v1);
L20:;
   {
    cl_object v7;
    cl_object v8;
    v7 = cl_gensym(0);
    v8 = cl_gensym(0);
    T0 = cl_list(3, ECL_SYM("THE",856), v6type, v7);
    T1 = cl_list(2, v5next, T0);
    T2 = cl_list(3, v7, v4list, T1);
    T3 = cl_list(2, VV[464], v8);
    T4 = cl_list(3, v8, ecl_make_fixnum(0), T3);
    T5 = cl_list(2, T2, T4);
    T6 = cl_list(2, ECL_SYM("NULL",605), v7);
    T7 = cl_list(2, T6, v8);
    T8 = cl_list(3, ECL_SYM("OR",614), ECL_SYM("NULL",605), v6type);
    T9 = cl_list(3, ECL_SYM("TYPE",869), T8, v7);
    T10 = cl_list(3, ECL_SYM("TYPE",869), VV[8], v8);
    T11 = cl_list(4, ECL_SYM("DECLARE",274), T9, T10, VV[452]);
    value0 = cl_list(4, ECL_SYM("DO",307), T5, T7, T11);
    return value0;
   }
  }
 }
}

#include "clx/macros.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclRFM7HYZ7_L9fUEX21(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = make_constant_base_string("SRC:CLX;MACROS.LISP.NEWEST");
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclRFM7HYZ7_L9fUEX21@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defmacro(VV[466]);                      /*  TYPE-CHECK      */
  si_Xmake_special(VV[3]);
  ecl_cmp_defmacro(VV[467]);                      /*  REQUIRED-ARG    */
  ecl_cmp_defmacro(VV[468]);                      /*  LROUND          */
  ecl_cmp_defmacro(VV[469]);                      /*  WROUND          */
  ecl_cmp_defun(VV[470]);                         /*  INDEX-INCREMENT */
  ecl_cmp_defun(VV[472]);                         /*  GETIFY          */
  ecl_cmp_defun(VV[473]);                         /*  PUTIFY          */
  ecl_cmp_defmacro(VV[474]);                      /*  DEFINE-ACCESSOR */
  si_putprop(VV[30], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[475]);                      /*  CARD32-GET      */
  ecl_cmp_defmacro(VV[476]);                      /*  CARD32-PUT      */
  si_putprop(VV[35], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[477]);                      /*  CARD29-GET      */
  ecl_cmp_defmacro(VV[478]);                      /*  CARD29-PUT      */
  si_putprop(VV[40], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[479]);                      /*  CARD16-GET      */
  ecl_cmp_defmacro(VV[480]);                      /*  CARD16-PUT      */
  si_putprop(VV[45], ecl_make_fixnum(1), VV[12]);
  ecl_cmp_defmacro(VV[481]);                      /*  CARD8-GET       */
  ecl_cmp_defmacro(VV[482]);                      /*  CARD8-PUT       */
  si_putprop(ECL_SYM("INTEGER",437), ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[483]);                      /*  INTEGER-GET     */
  ecl_cmp_defmacro(VV[484]);                      /*  INTEGER-PUT     */
  si_putprop(VV[54], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[485]);                      /*  INT16-GET       */
  ecl_cmp_defmacro(VV[486]);                      /*  INT16-PUT       */
  si_putprop(VV[59], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[487]);                      /*  RGB-VAL-GET     */
  ecl_cmp_defmacro(VV[488]);                      /*  RGB-VAL-PUT     */
  si_putprop(VV[64], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[489]);                      /*  ANGLE-GET       */
  ecl_cmp_defmacro(VV[490]);                      /*  ANGLE-PUT       */
  si_putprop(ECL_SYM("BIT",123), ecl_make_fixnum(0), VV[12]);
  ecl_cmp_defmacro(VV[491]);                      /*  BIT-GET         */
  ecl_cmp_defmacro(VV[492]);                      /*  BIT-PUT         */
  si_putprop(ECL_SYM("BOOLEAN",155), ecl_make_fixnum(1), VV[12]);
  ecl_cmp_defmacro(VV[493]);                      /*  BOOLEAN-GET     */
  ecl_cmp_defmacro(VV[494]);                      /*  BOOLEAN-PUT     */
  si_putprop(VV[74], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[495]);                      /*  DRAWABLE-GET    */
  ecl_cmp_defmacro(VV[496]);                      /*  DRAWABLE-PUT    */
  si_putprop(VV[80], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[497]);                      /*  WINDOW-GET      */
  ecl_cmp_defmacro(VV[498]);                      /*  WINDOW-PUT      */
  si_putprop(VV[85], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[499]);                      /*  PIXMAP-GET      */
  ecl_cmp_defmacro(VV[500]);                      /*  PIXMAP-PUT      */
  si_putprop(VV[90], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[501]);                      /*  GCONTEXT-GET    */
  ecl_cmp_defmacro(VV[502]);                      /*  GCONTEXT-PUT    */
  si_putprop(VV[95], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[503]);                      /*  CURSOR-GET      */
  ecl_cmp_defmacro(VV[504]);                      /*  CURSOR-PUT      */
  si_putprop(VV[100], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[505]);                      /*  COLORMAP-GET    */
  ecl_cmp_defmacro(VV[506]);                      /*  COLORMAP-PUT    */
  si_putprop(VV[105], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[507]);                      /*  FONT-GET        */
  ecl_cmp_defmacro(VV[508]);                      /*  FONT-PUT        */
  si_putprop(ECL_SYM("KEYWORD",449), ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[509]);                      /*  KEYWORD-GET     */
  ecl_cmp_defmacro(VV[510]);                      /*  KEYWORD-PUT     */
  si_putprop(VV[117], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[511]);                      /*  RESOURCE-ID-GET */
  ecl_cmp_defmacro(VV[512]);                      /*  RESOURCE-ID-PUT */
  si_putprop(VV[120], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[513]);                      /*  RESOURCE-ID-OR-NIL-GET */
  ecl_cmp_defmacro(VV[514]);                      /*  RESOURCE-ID-OR-NIL-PUT */
  ecl_cmp_defmacro(VV[515]);                      /*  CHAR-INFO-GET   */
  si_putprop(VV[131], ecl_make_fixnum(1), VV[12]);
  ecl_cmp_defmacro(VV[516]);                      /*  MEMBER8-GET     */
  ecl_cmp_defmacro(VV[517]);                      /*  MEMBER8-PUT     */
  si_putprop(VV[131], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[518]);                      /*  MEMBER8-PUT-PREDICATING */
  si_putprop(VV[137], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[519]);                      /*  MEMBER16-GET    */
  ecl_cmp_defmacro(VV[520]);                      /*  MEMBER16-PUT    */
  si_putprop(VV[137], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[521]);                      /*  MEMBER16-PUT-PREDICATING */
  si_putprop(ECL_SYM("MEMBER",552), ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[522]);                      /*  MEMBER-GET      */
  ecl_cmp_defmacro(VV[523]);                      /*  MEMBER-PUT      */
  si_putprop(ECL_SYM("MEMBER",552), ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[524]);                      /*  MEMBER-PUT-PREDICATING */
 {
  cl_object T0;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC59member_vector,ECL_NIL,Cblock,1);
   T0 = v1;
  }
  si_do_deftype(3, VV[144], VVtemp[0], T0);
 }
  si_putprop(VV[144], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[525]);                      /*  MEMBER-VECTOR-GET */
  ecl_cmp_defmacro(VV[526]);                      /*  MEMBER-VECTOR-PUT */
  si_putprop(VV[144], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[527]);                      /*  MEMBER-VECTOR-PUT-PREDICATING */
  si_putprop(VV[148], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[528]);                      /*  MEMBER16-VECTOR-GET */
  ecl_cmp_defmacro(VV[529]);                      /*  MEMBER16-VECTOR-PUT */
  si_putprop(VV[148], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[530]);                      /*  MEMBER16-VECTOR-PUT-PREDICATING */
  si_putprop(VV[152], ecl_make_fixnum(1), VV[12]);
  ecl_cmp_defmacro(VV[531]);                      /*  MEMBER8-VECTOR-GET */
  ecl_cmp_defmacro(VV[532]);                      /*  MEMBER8-VECTOR-PUT */
  si_putprop(VV[152], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[533]);                      /*  MEMBER8-VECTOR-PUT-PREDICATING */
  si_putprop(VV[156], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[534]);                      /*  BOOLE-CONSTANT-GET */
  ecl_cmp_defmacro(VV[535]);                      /*  BOOLE-CONSTANT-PUT */
  si_putprop(VV[156], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[536]);                      /*  BOOLE-CONSTANT-PUT-PREDICATING */
  si_putprop(ECL_SYM("NULL",605), ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[537]);                      /*  NULL-GET        */
  ecl_cmp_defmacro(VV[538]);                      /*  NULL-PUT        */
  si_putprop(VV[164], ecl_make_fixnum(1), VV[12]);
  ecl_cmp_defmacro(VV[539]);                      /*  PAD8-GET        */
  ecl_cmp_defmacro(VV[540]);                      /*  PAD8-PUT        */
  si_putprop(VV[167], ecl_make_fixnum(2), VV[12]);
  ecl_cmp_defmacro(VV[541]);                      /*  PAD16-GET       */
  ecl_cmp_defmacro(VV[542]);                      /*  PAD16-PUT       */
  si_putprop(VV[170], ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[543]);                      /*  PAD32-GET       */
  ecl_cmp_defmacro(VV[544]);                      /*  PAD32-PUT       */
  si_putprop(VV[173], ecl_make_fixnum(32), VV[12]);
  ecl_cmp_defmacro(VV[545]);                      /*  BIT-VECTOR256-GET */
  ecl_cmp_defmacro(VV[546]);                      /*  BIT-VECTOR256-PUT */
  si_putprop(ECL_SYM("STRING",805), ECL_NIL, VV[12]);
  ecl_cmp_defmacro(VV[547]);                      /*  STRING-GET      */
  ecl_cmp_defmacro(VV[548]);                      /*  STRING-PUT      */
  si_putprop(ECL_SYM("SEQUENCE",741), ECL_NIL, VV[12]);
  ecl_cmp_defmacro(VV[549]);                      /*  SEQUENCE-GET    */
  ecl_cmp_defmacro(VV[550]);                      /*  SEQUENCE-PUT    */
  ecl_cmp_defmacro(VV[551]);                      /*  CLIENT-MESSAGE-EVENT-GET-SEQUENCE */
  ecl_cmp_defmacro(VV[552]);                      /*  CLIENT-MESSAGE-EVENT-PUT-SEQUENCE */
  si_putprop(VV[225], ecl_make_fixnum(20), VV[12]);
  ecl_cmp_defmacro(VV[553]);                      /*  CLIENT-MESSAGE-SEQUENCE-GET */
  ecl_cmp_defmacro(VV[554]);                      /*  CLIENT-MESSAGE-SEQUENCE-PUT */
  si_putprop(VV[229], ecl_make_fixnum(0), VV[12]);
  ecl_cmp_defmacro(VV[555]);                      /*  CODE-GET        */
  ecl_cmp_defmacro(VV[556]);                      /*  CODE-PUT        */
  si_putprop(VV[229], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[557]);                      /*  CODE-PUT-PREDICATING */
  si_putprop(ECL_SYM("LENGTH",476), ecl_make_fixnum(0), VV[12]);
  ecl_cmp_defmacro(VV[558]);                      /*  LENGTH-GET      */
  ecl_cmp_defmacro(VV[559]);                      /*  LENGTH-PUT      */
  si_putprop(ECL_SYM("LENGTH",476), ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[560]);                      /*  LENGTH-PUT-PREDICATING */
  si_do_deftype(3, VV[238], VVtemp[1], VV[45]);
  si_putprop(VV[238], ecl_make_fixnum(0), VV[12]);
  ecl_cmp_defmacro(VV[561]);                      /*  DATA-GET        */
  ecl_cmp_defmacro(VV[562]);                      /*  DATA-PUT        */
  si_putprop(VV[238], ECL_T, VV[135]);
  ecl_cmp_defmacro(VV[563]);                      /*  DATA-PUT-PREDICATING */
  ecl_cmp_defmacro(VV[564]);                      /*  OR-EXPAND       */
  si_putprop(ECL_SYM("OR",614), ecl_make_fixnum(4), VV[12]);
  ecl_cmp_defmacro(VV[566]);                      /*  OR-GET          */
  ecl_cmp_defmacro(VV[567]);                      /*  OR-PUT          */
  si_putprop(VV[251], ECL_NIL, VV[12]);
  ecl_cmp_defun(VV[568]);                         /*  MASK-GET        */
  ecl_cmp_defun(VV[569]);                         /*  MASK-PUT        */
  si_putprop(ECL_SYM("PROGN",671), ECL_NIL, VV[12]);
  ecl_cmp_defmacro(VV[570]);                      /*  PROGN-GET       */
  ecl_cmp_defmacro(VV[571]);                      /*  PROGN-PUT       */
  ecl_cmp_defmacro(VV[572]);                      /*  CHECK-PUT       */
  ecl_cmp_defun(VV[573]);                         /*  GET-PUT-ITEMS   */
  ecl_cmp_defmacro(VV[574]);                      /*  WITH-BUFFER-REQUEST-INTERNAL */
  ecl_cmp_defmacro(VV[575]);                      /*  WITH-BUFFER-REQUEST */
  ecl_cmp_defmacro(VV[576]);                      /*  WITH-BUFFER-REQUEST-AND-REPLY */
  ecl_cmp_defmacro(VV[577]);                      /*  COMPARE-REQUEST */
  ecl_cmp_defmacro(VV[578]);                      /*  PUT-ITEMS       */
  ecl_cmp_defmacro(VV[579]);                      /*  DECODE-TYPE     */
  ecl_cmp_defmacro(VV[580]);                      /*  ENCODE-TYPE     */
  ecl_cmp_defmacro(VV[581]);                      /*  SET-DECODE-TYPE */
  si_do_defsetf(VV[328], VV[331]);
  si_Xmake_constant(VV[332], ecl_make_fixnum(1));
  si_Xmake_constant(VV[333], ecl_make_fixnum(2));
  si_Xmake_constant(VV[334], ecl_make_fixnum(3));
  si_Xmake_constant(VV[335], ecl_make_fixnum(4));
  si_Xmake_constant(VV[336], ecl_make_fixnum(5));
  si_Xmake_constant(VV[337], ecl_make_fixnum(6));
  si_Xmake_constant(VV[338], ecl_make_fixnum(7));
  si_Xmake_constant(VV[339], ecl_make_fixnum(8));
  si_Xmake_constant(VV[340], ecl_make_fixnum(9));
  si_Xmake_constant(VV[341], ecl_make_fixnum(10));
  si_Xmake_constant(VV[342], ecl_make_fixnum(11));
  si_Xmake_constant(VV[343], ecl_make_fixnum(12));
  si_Xmake_constant(VV[344], ecl_make_fixnum(13));
  si_Xmake_constant(VV[345], ecl_make_fixnum(14));
  si_Xmake_constant(VV[346], ecl_make_fixnum(15));
  si_Xmake_constant(VV[347], ecl_make_fixnum(16));
  si_Xmake_constant(VV[348], ecl_make_fixnum(17));
  si_Xmake_constant(VV[349], ecl_make_fixnum(18));
  si_Xmake_constant(VV[350], ecl_make_fixnum(19));
  si_Xmake_constant(VV[351], ecl_make_fixnum(20));
  si_Xmake_constant(VV[352], ecl_make_fixnum(21));
  si_Xmake_constant(VV[353], ecl_make_fixnum(22));
  si_Xmake_constant(VV[354], ecl_make_fixnum(23));
  si_Xmake_constant(VV[355], ecl_make_fixnum(24));
  si_Xmake_constant(VV[356], ecl_make_fixnum(25));
  si_Xmake_constant(VV[357], ecl_make_fixnum(26));
  si_Xmake_constant(VV[358], ecl_make_fixnum(27));
  si_Xmake_constant(VV[359], ecl_make_fixnum(28));
  si_Xmake_constant(VV[360], ecl_make_fixnum(29));
  si_Xmake_constant(VV[361], ecl_make_fixnum(30));
  si_Xmake_constant(VV[362], ecl_make_fixnum(31));
  si_Xmake_constant(VV[363], ecl_make_fixnum(32));
  si_Xmake_constant(VV[364], ecl_make_fixnum(33));
  si_Xmake_constant(VV[365], ecl_make_fixnum(34));
  si_Xmake_constant(VV[366], ecl_make_fixnum(35));
  si_Xmake_constant(VV[367], ecl_make_fixnum(36));
  si_Xmake_constant(VV[368], ecl_make_fixnum(37));
  si_Xmake_constant(VV[369], ecl_make_fixnum(38));
  si_Xmake_constant(VV[370], ecl_make_fixnum(39));
  si_Xmake_constant(VV[371], ecl_make_fixnum(40));
  si_Xmake_constant(VV[372], ecl_make_fixnum(41));
  si_Xmake_constant(VV[373], ecl_make_fixnum(42));
  si_Xmake_constant(VV[374], ecl_make_fixnum(43));
  si_Xmake_constant(VV[375], ecl_make_fixnum(44));
  si_Xmake_constant(VV[376], ecl_make_fixnum(45));
  si_Xmake_constant(VV[377], ecl_make_fixnum(46));
  si_Xmake_constant(VV[378], ecl_make_fixnum(47));
  si_Xmake_constant(VV[379], ecl_make_fixnum(48));
  si_Xmake_constant(VV[380], ecl_make_fixnum(49));
  si_Xmake_constant(VV[381], ecl_make_fixnum(50));
  si_Xmake_constant(VV[382], ecl_make_fixnum(51));
  si_Xmake_constant(VV[383], ecl_make_fixnum(52));
  si_Xmake_constant(VV[384], ecl_make_fixnum(53));
  si_Xmake_constant(VV[385], ecl_make_fixnum(54));
  si_Xmake_constant(VV[386], ecl_make_fixnum(55));
  si_Xmake_constant(VV[387], ecl_make_fixnum(56));
  si_Xmake_constant(VV[388], ecl_make_fixnum(57));
  si_Xmake_constant(VV[389], ecl_make_fixnum(58));
  si_Xmake_constant(VV[390], ecl_make_fixnum(59));
  si_Xmake_constant(VV[391], ecl_make_fixnum(60));
  si_Xmake_constant(VV[392], ecl_make_fixnum(61));
  si_Xmake_constant(VV[393], ecl_make_fixnum(62));
  si_Xmake_constant(VV[394], ecl_make_fixnum(63));
  si_Xmake_constant(VV[395], ecl_make_fixnum(64));
  si_Xmake_constant(VV[396], ecl_make_fixnum(65));
  si_Xmake_constant(VV[397], ecl_make_fixnum(66));
  si_Xmake_constant(VV[398], ecl_make_fixnum(67));
  si_Xmake_constant(VV[399], ecl_make_fixnum(68));
  si_Xmake_constant(VV[400], ecl_make_fixnum(69));
  si_Xmake_constant(VV[401], ecl_make_fixnum(70));
  si_Xmake_constant(VV[402], ecl_make_fixnum(71));
  si_Xmake_constant(VV[403], ecl_make_fixnum(72));
  si_Xmake_constant(VV[404], ecl_make_fixnum(73));
  si_Xmake_constant(VV[405], ecl_make_fixnum(74));
  si_Xmake_constant(VV[406], ecl_make_fixnum(75));
  si_Xmake_constant(VV[407], ecl_make_fixnum(76));
  si_Xmake_constant(VV[408], ecl_make_fixnum(77));
  si_Xmake_constant(VV[409], ecl_make_fixnum(78));
  si_Xmake_constant(VV[410], ecl_make_fixnum(79));
  si_Xmake_constant(VV[411], ecl_make_fixnum(80));
  si_Xmake_constant(VV[412], ecl_make_fixnum(81));
  si_Xmake_constant(VV[413], ecl_make_fixnum(82));
  si_Xmake_constant(VV[414], ecl_make_fixnum(83));
  si_Xmake_constant(VV[415], ecl_make_fixnum(84));
  si_Xmake_constant(VV[416], ecl_make_fixnum(85));
  si_Xmake_constant(VV[417], ecl_make_fixnum(86));
  si_Xmake_constant(VV[418], ecl_make_fixnum(87));
  si_Xmake_constant(VV[419], ecl_make_fixnum(88));
  si_Xmake_constant(VV[420], ecl_make_fixnum(89));
  si_Xmake_constant(VV[421], ecl_make_fixnum(90));
  si_Xmake_constant(VV[422], ecl_make_fixnum(91));
  si_Xmake_constant(VV[423], ecl_make_fixnum(92));
  si_Xmake_constant(VV[424], ecl_make_fixnum(93));
  si_Xmake_constant(VV[425], ecl_make_fixnum(94));
  si_Xmake_constant(VV[426], ecl_make_fixnum(95));
  si_Xmake_constant(VV[427], ecl_make_fixnum(96));
  si_Xmake_constant(VV[428], ecl_make_fixnum(97));
  si_Xmake_constant(VV[429], ecl_make_fixnum(98));
  si_Xmake_constant(VV[430], ecl_make_fixnum(99));
  si_Xmake_constant(VV[431], ecl_make_fixnum(100));
  si_Xmake_constant(VV[432], ecl_make_fixnum(101));
  si_Xmake_constant(VV[433], ecl_make_fixnum(102));
  si_Xmake_constant(VV[434], ecl_make_fixnum(103));
  si_Xmake_constant(VV[435], ecl_make_fixnum(104));
  si_Xmake_constant(VV[436], ecl_make_fixnum(105));
  si_Xmake_constant(VV[437], ecl_make_fixnum(106));
  si_Xmake_constant(VV[438], ecl_make_fixnum(107));
  si_Xmake_constant(VV[439], ecl_make_fixnum(108));
  si_Xmake_constant(VV[440], ecl_make_fixnum(109));
  si_Xmake_constant(VV[441], ecl_make_fixnum(110));
  si_Xmake_constant(VV[442], ecl_make_fixnum(111));
  si_Xmake_constant(VV[443], ecl_make_fixnum(112));
  si_Xmake_constant(VV[444], ecl_make_fixnum(113));
  si_Xmake_constant(VV[445], ecl_make_fixnum(114));
  si_Xmake_constant(VV[446], ecl_make_fixnum(115));
  si_Xmake_constant(VV[447], ecl_make_fixnum(116));
  si_Xmake_constant(VV[448], ecl_make_fixnum(117));
  si_Xmake_constant(VV[449], ecl_make_fixnum(118));
  si_Xmake_constant(VV[450], ecl_make_fixnum(119));
  si_Xmake_constant(VV[451], ecl_make_fixnum(127));
  ecl_cmp_defmacro(VV[582]);                      /*  THREADED-ATOMIC-PUSH */
  ecl_cmp_defmacro(VV[583]);                      /*  THREADED-ATOMIC-POP */
  ecl_cmp_defmacro(VV[584]);                      /*  THREADED-NCONC  */
  ecl_cmp_defmacro(VV[585]);                      /*  THREADED-PUSH   */
  ecl_cmp_defmacro(VV[586]);                      /*  THREADED-POP    */
  ecl_cmp_defmacro(VV[587]);                      /*  THREADED-ENQUEUE */
  ecl_cmp_defmacro(VV[588]);                      /*  THREADED-DEQUEUE */
  ecl_cmp_defmacro(VV[589]);                      /*  THREADED-REQUEUE */
  ecl_cmp_defmacro(VV[590]);                      /*  THREADED-DOLIST */
  ecl_cmp_defmacro(VV[591]);                      /*  THREADED-DELETE */
  ecl_cmp_defmacro(VV[592]);                      /*  THREADED-LENGTH */
}
